/* FILE.c */

#include "EV3.h"
#include "FILE.h"

/*=====================================================================
  t@C\֐
  =====================================================================*/
/*
 * CFile
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void CFile(struct CFile *this)
{
	/* l */
	CTime(&this->T);
	this->fp = NULL;
	
	/* ߂ */
	return;
}

/*
 * Write
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int Write(struct CFile *this, char *filename, char ch)
{
	if((this->fp = fopen(filename, "w")) == NULL){
		return	NG;
	}
	else if(fputc(ch, this->fp) == ch){
		fclose(this->fp);
		return	OK;
	}
	else{
		fclose(this->fp);
		return	NG;
	}
}

/* 񏑂 */
int WriteString(struct CFile *this, char *filename, char *str){
	if((this->fp = fopen(filename, "w")) == NULL){
		return	NG;
	}
	/* \n͒ǋLȂ */
	else if(fputs(str, this->fp) >= 0){
		fclose(this->fp);
		/* ݐ */
		return	OK;
	}
	else{
		fclose(this->fp);
		/* ݎs */
		return	NG;
	}
}

/*
 * Read
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int Read(struct CFile *this, char *filename, char *p_ch)
{
	if((this->fp = fopen(filename, "r")) == NULL){
		return NG;
	}
	else if((*p_ch = fgetc(this->fp)) == EOF){
		fclose(this->fp);
		return ONE_MORE_TIME;
	}
	else if(*p_ch == '\n'){
		fclose(this->fp);
		return ONE_MORE_TIME;
	}
	else if(*p_ch == 'N'){
		fclose(this->fp);
		return ONE_MORE_TIME;
	}
	else{
		fclose(this->fp);
		return OK;
	}
}

/*
 * ReadString
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int ReadString(struct CFile *this, char *filename, char *str, int strlength)
{
	if((this->fp = fopen(filename, "r")) == NULL){
		return NG;
	}
	else if(fgets(str, strlength, this->fp) == NULL){
		fclose(this->fp);
		return ONE_MORE_TIME;
	}
	else if(str[0] == '\n'){
		fclose(this->fp);
		return ONE_MORE_TIME;
	}
	else if(str[0] == 'N'){
		fclose(this->fp);
		return ONE_MORE_TIME;
	}
	else{
		fclose(this->fp);
		return OK;
	}
}

/*
 * PermitCommand_Write
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int PermitCommand_Write(struct CFile *this, char PermitCommand)
{
	switch(Write(this, "PermitCommand.txt\0", PermitCommand)){
	case NG:
		printf("PermitCommand.txt֏ݎs\n");
		WaitSecond(&this->T, 5);
		return	NG;
		break;
	case OK:
		return	OK;
		break;
	default:
		return	NG;
		break;
	}
	
	return NG;
}

/*
 * Command_Read
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int Command_Read(struct CFile *this, char *p_Command)
{
	switch(Read(this, "Command.txt\0", p_Command)){
	case NG:
		printf("Command.txtJ܂\n");
		WaitSecond(&this->T, 5);
		return NG;
		break;
	case ONE_MORE_TIME:
		WaitSecond(&this->T, 1);
		return ONE_MORE_TIME;
		break;
	default:
		return OK;
		break;
	}
	
	return NG;
}

/*
 * Command_Write
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int Command_Write(struct CFile *this, char Command)
{
	switch(Write(this, "Command.txt\0", Command)){
	case NG:
		printf("Command.txt|ł܂\n");
		WaitSecond(&this->T, 5);
		return NG;
		break;
	case OK:
		return OK;
		break;
	default:
		return	NG;
		break;
	}
	
	return NG;
}

/*
 * PermitTurnOpen_Write
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int PermitTurnOpen_Write(struct CFile *this, char PermitTurnOpen)
{
	switch(Write(this, "PermitTurnOpen.txt\0", PermitTurnOpen)){
	case NG:
		printf("PermitTurnOpen.txt֏ݎs\n");
		WaitSecond(&this->T, 5);
		return	NG;
		break;
	case OK:
		return	OK;
		break;
	default:
		return	NG;
		break;
	}
	
	return NG;
}

/*
 * TurnOpen_Read
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int TurnOpen_Read(struct CFile *this, char *p_chTurnOpen)
{
	switch(Read(this, "TurnOpen.txt\0", p_chTurnOpen)){
	case NG:
		printf("TurnOpen.txtJ܂\n");
		WaitSecond(&this->T, 5);
		return NG;
		break;
	case ONE_MORE_TIME:
		WaitSecond(&this->T, 1);
		return ONE_MORE_TIME;
		break;
	default:
		return OK;
		break;
	}
	
	return NG;
}

/*
 * TurnOpen_Write
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int TurnOpen_Write(struct CFile *this, char TurnOpen)
{
	switch(Write(this, "TurnOpen.txt\0", TurnOpen)){
	case NG:
		printf("TurnOpen.txt|ł܂\n");
		WaitSecond(&this->T, 5);
		return NG;
		break;
	case OK:
		return OK;
		break;
	default:
		return	NG;
		break;
	}
	
	return NG;
}

/*
 * Motor_Write
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void Motor_Write(struct CFile *this, char Motor)
{
	switch(Write(this, "Motor.txt\0", Motor)){
	case NG:
		printf("Motor.txt֏ݎs\n");
		WaitSecond(&this->T, 5);
		exit(1);
		break;
	case OK:
		return;
		break;
	default:
		exit(1);
		break;
	}
	
	/* ߂ */
	return;
}

/*
 * Motor_Read
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
char Motor_Read(struct CFile *this)
{
	char ch;
	char *p_ch;
	ch = '\0';
	p_ch = &ch;

	switch(Read(this, "Motor.txt\0", p_ch)){
	case NG:
		exit(1);
		break;
	case ONE_MORE_TIME:
		return '\0';
		break;
	case OK:
		return ch;
		break;
	default:
		exit(1);
		break;
	}
	
	return '\0';
}

/*
 * Limit_Read
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void Limit_Read(struct CFile *this, char *str)
{
	switch(ReadString(this, "Limit.txt\0", str, 9)){
	case NG:
		printf("Limit.txtJ܂\n");
		WaitSecond(&this->T, 5);
		exit(1);
		break;
	case ONE_MORE_TIME:
		return;
		break;
	default:
		return;
		break;
	}
	
	/* ߂ */
	return;
}
