/* UPDN.h */

#ifndef TIME_h
#define	TIME_h
#include "TIME.h"
#endif

#ifndef FILE_h
#define	FILE_h
#include "FILE.h"
#endif

/*=====================================================================
  ㏸~\\
  =====================================================================*/
struct Position
{
	int m_UNSL;
	int m_UNST;
	int m_UPSL;
	int m_UPST;
	/* ~ʒu */
	int *p_UnderSlow;
	/* ~~ʒu */
	int *p_UnderStop;
	/* ㏸ʒu */
	int *p_UpperSlow;
	/* ㏸~ʒu */
	int *p_UpperStop;
	/* Sleepp */
	int fstop;
	int *p_fstop;
	int fmove;
	int *p_fmove;
};

/* ㏸ */
struct UpMotor
{
	struct CFile LF;
};

/* ~ */
struct DownMotor
{
	struct CFile LF;
};

/* Gx[^[̈ʒuzO */
struct WaitPositionChangeLog
{
	struct CFile LF;
	char strLimit[9];
	char *p_strLimit;
	int tmp;
};

/*=====================================================================
  ㏸~\vg^Cv錾
  =====================================================================*/
void Position(struct Position *this);
/* ㏸ */
void UpMotor(struct UpMotor *this);
void OnUpMotor(struct UpMotor *this, struct Position P);
/* ~ */
void DownMotor(struct DownMotor *this);
void OnDownMotor(struct DownMotor *this, struct Position P);
/* oߎ */
void WaitPositionChangeLog(struct WaitPositionChangeLog *this);
void OnInitWaitPositionChangeLog(struct WaitPositionChangeLog *this, struct Position P);
void OnWaitUpPositionChangeLog(struct WaitPositionChangeLog *this, struct Position P);
void OnWaitDownPositionChangeLog(struct WaitPositionChangeLog *this, struct Position P);
/* ㏸ */
void Up(struct Position P, struct UpMotor UPMT, struct WaitPositionChangeLog WPCL);
/* ~ */
void Down(struct Position P, struct DownMotor DNMT, struct WaitPositionChangeLog WPCL);
