/* FILE.h */

#ifndef PRINTF_h
#define PRINTF_h
#include "PRINTF.h"
#endif

#ifndef TIME_h
#define	TIME_h
#include "TIME.h"
#endif

/*=====================================================================
  t@C\\
  =====================================================================*/
#ifdef NOTUSE_FILES
struct Handle_Status
{
	char safety;
	char *p_limit;
	char limit[9];
	char motor;
	char command;
	char permitcommand;
};

struct Status
{
	struct Handle_Status *p_status;
};
#endif

/* t@CXg[ */
struct CFile
{
	FILE *fp;
};

/*=====================================================================
  t@C\vg^Cv錾
  =====================================================================*/
#ifdef NOTUSE_FILES
void Status(struct Status *this);
#endif

void CFile(struct CFile *this);
int Write(struct CFile *this, char *filename, char ch);
int WriteString(struct CFile *this, char *filename, char *str);
int Read(struct CFile *this, char *filename, char *p_ch);
int ReadString(struct CFile *this, char *filename, char *str, int strlength);
int PermitCommand_Write(struct CFile *this, char PermitCommand);
int Command_Read(struct CFile *this, char *p_Command);
int Command_Write(struct CFile *this, char Command);
int PermitTurnOpen_Write(struct CFile *this, char PermitTurnOpen);
int TurnOpen_Read(struct CFile *this, char *p_chTurnOpen);
int TurnOpen_Write(struct CFile *this, char TurnOpen);
void Motor_Write(struct CFile *this, char Motor);
char Motor_Read(struct CFile *this);
void Limit_Read(struct CFile *this, char *str);
