/* PRINTF.c */

#include "EV4.h"
#include "PRINTF.h"

/*=====================================================================
  \̂߂̊֐
  =====================================================================*/
void PrintF(int mode, char *str)
{
#ifdef USE_H8_3052F
	static char buff[64];
#endif
	switch(mode)
	{
	case Panel:
#ifdef USE_H8_3052F
		sprintf(buff,"\f%s", str);
		PrintSCI("%s",buff);
		PrintLCD(buff);
#else
#ifdef USE_GCC
		printf("\n%s", str);
#else
		printf("%s", str);
#endif
#endif
		break;
	case InputCommand:
#ifndef USE_H8_3052F
		printf("%s", str);
#endif
		break;
	case Monitor:
#ifdef USE_H8_3052F
		sprintf(buff,"%s", str);
		PrintSCI("%s",buff);
		write_buff(buff,strlen(buff)+1);
#else
		printf("%s", str);
#endif
		break;
	default:
		break;
	}
	
	return;
}
