/* SIM.c : C vWFNg t@CłB */

#include "EV4.h"
#include "SIM.h"

/*=====================================================================
  V~[^֐
  =====================================================================*/
void CSimulator(struct CSimulator *this, struct Handle_Thread *th)
{
	/*  */
	CTime(&this->T, th);
	SetCurrentTime(&this->T);
	this->p_ch = &this->ch;
	this->p_str = &this->str[0];
	CFile(&this->SF);
	CFile(&this->CF);
	CFile(&this->MF);
	CFile(&this->LF);
}

void OnSimulator(struct CSimulator *this, struct Handle_Thread *th)
{
#ifdef USE_H8_3052F
	int i;
	i = 0;
#endif

	/* I */
	if(Read(&this->CF, "Command.txt\0", this->p_ch) == NG) return;
	if(this->ch == 'q') return;

	/* ~ */
	if(Read(&this->SF, "Safety.txt\0", this->p_ch) == NG) return;
	if(this->ch == 's'){
#ifdef USE_H8_3052F
		if(Write(&this->CF, "Command.txt\0", 'N') == NG) return;
		if(Write(&this->CF, "PermitCommand.txt\0", 'N') == NG) return;
#else
		this->T.tmpTimeSafety = clock();
#endif
		return;
	}
	else if(this->ch == 'Y')
	{
#ifdef USE_H8_3052F
		for(i = 0; i < 20000; i++){}
		if(Write(&this->CF, "PermitCommand.txt\0", 'c') == NG) return;
#else
		if(clock() > this->T.tmpTimeSafety + (2 * CLOCKS_PER_SEC)){}
#endif
		if(Write(&this->SF, "Safety.txt\0", 'r') == NG) return;
		return;
	}

	/* [^[߉ */
	if(Read(&this->MF, "Motor.txt\0", this->p_ch) == NG) return;

	/* ~bgXCb`̑Oԓǂݍ */
	if(ReadString(&this->LF, "Limit.txt\0", this->p_str, 9) == NG) return;

	/* ~bgXCb`̐Vԍ쐬 */
	if((this->ch == 'u') || (this->ch == 'U') || (this->ch == 'j')){
		if(this->str[0] == 'y') this->str[0] = 'n';
		else if(this->str[1] == 'y') this->str[1] = 'n';
		else if(this->str[2] == 'n') this->str[2] = 'y';
		else if(this->str[3] == 'n') this->str[3] = 'y';
	}
	else if((this->ch == 'd') || (this->ch == 'D') || (this->ch == 'k')){
		if(this->str[3] == 'y') this->str[3] = 'n';
		else if(this->str[2] == 'y') this->str[2] = 'n';
		else if(this->str[1] == 'n') this->str[1] = 'y';
		else if(this->str[0] == 'n') this->str[0] = 'y';
	}
	if((this->ch == 'o') || (this->ch == 'O') || (this->ch == 'h')){
		if(this->str[4] == 'y') this->str[4] = 'n';
		else if(this->str[5] == 'y') this->str[5] = 'n';
		else if(this->str[6] == 'n') this->str[6] = 'y';
		else if(this->str[7] == 'n') this->str[7] = 'y';
	}
	else if(this->ch == 'c'){
		if(this->str[7] == 'y');
		else if(this->str[6] == 'y') this->str[6] = 'n';
		else if(this->str[5] == 'n');
		else if(this->str[4] == 'n') this->str[4] = 'y';
	}
	else if(this->ch == 'C'){
		if(this->str[7] == 'y');
		else if(this->str[6] == 'y');
		else if(this->str[5] == 'n') this->str[5] = 'y';
		else if(this->str[4] == 'n');
	}
	else if(this->ch == 't'){
		if(this->str[7] == 'y') this->str[7] = 'n';
		else if(this->str[6] == 'y');
		else if(this->str[5] == 'n');
		else if(this->str[4] == 'n');
	}
	
	this->str[8] = '\0';

	/* ~bgXCb`̐Vԏ */
	if(WriteString(&this->LF, "Limit.txt\0", this->str) == NG) return;
	
	/* ĕ\ */
	Disp(this->ch, this->str);
	
	/* Ԍo */
	WaitSecond(&this->T, 1);
	SetCurrentTime(&this->T);

	return;
}

/*
 * \֐
 */
void Disp(char ch, char str[9])
{
	int	i;
	
#ifndef USE_GCC
#ifndef USE_H8_3052F
	CLEAR;
#endif
#endif
	
	if	   (((ch == 'u') && (str[3] == 'y') && (str[2] == 'y'))
		||  ((ch == 'k') && (str[3] == 'n') && (str[2] == 'y')))
	{
		for(i = 0; i < 8; i++)
		{
				PrintF(Monitor, "\n        0000000000000000        ");
		}
		for(i = 8; i < 24; i++)
		{
				PrintF(Monitor, "\n                                ");
		}
	}
	else if(((ch == 'U') && (str[3] == 'n') && (str[2] == 'y'))
		||  ((ch == 'd') && (str[3] == 'n') && (str[2] == 'n') && (str[1] == 'n') && (str[0] == 'n')))
	{
		for(i = 0; i < 4; i++)
		{
				PrintF(Monitor, "\n                                ");
		}
		for(i = 4; i < 12; i++)
		{
				PrintF(Monitor, "\n        0000000000000000        ");
		}
		for(i = 12; i < 24; i++)
		{
				PrintF(Monitor, "\n                                ");
		}
	}
	else if(((ch == 'u') && (str[3] == 'n') && (str[2] == 'n') && (str[1] == 'n') && (str[0] == 'n'))
		||  ((ch == 'D') && (str[1] == 'y') && (str[0] == 'n')))
	{
		for(i = 0; i < 12; i++)
		{
				PrintF(Monitor, "\n                                ");
		}
		for(i = 12; i < 20; i++)
		{
				PrintF(Monitor, "\n        0000000000000000        ");
		}
		for(i = 20; i < 24; i++)
		{
				PrintF(Monitor, "\n                                ");
		}
	}
	else if(((ch == 'j') && (str[1] == 'y') && (str[0] == 'n'))
		||  ((ch == 'd') && (str[1] == 'y') && (str[0] == 'y')))
	{
		for(i = 0; i < 16; i++)
		{
				PrintF(Monitor, "\n                                ");
		}
		for(i = 16; i < 24; i++)
		{
				PrintF(Monitor, "\n        0000000000000000        ");
		}
	}
	else if((str[3] == 'y') && (str[2] == 'y'))
	{
		if     (((ch == 's') && (str[7] == 'y') && (str[6] == 'y'))
			||  ((ch == 'o') && (str[7] == 'y') && (str[6] == 'y'))
			||  ((ch == 't') && (str[7] == 'n') && (str[6] == 'y')))
		{
			for(i = 0; i < 8; i++)
			{
				PrintF(Monitor, "\n00000000                00000000");
			}
			for(i = 8; i < 24; i++)
			{
				PrintF(Monitor, "\n                                ");
			}
		}
		else if(((ch == 'O') && (str[7] == 'n') && (str[6] == 'y'))
			||  ((ch == 'c') && (str[7] == 'n') && (str[6] == 'n') && (str[5] == 'n') && (str[4] == 'n')))
		{
			for(i = 0; i < 8; i++)
			{
				PrintF(Monitor, "\n  00000000            00000000  ");
			}
			for(i = 8; i < 24; i++)
			{
				PrintF(Monitor, "\n                                ");
			}
		}
		else if(((ch == 'o') && (str[7] == 'n') && (str[6] == 'n') && (str[5] == 'n') && (str[4] == 'n'))
			||  ((ch == 'C') && (str[5] == 'y') && (str[4] == 'n')))
		{
			for(i = 0; i < 8; i++)
			{
				PrintF(Monitor, "\n      00000000    00000000      ");
			}
			for(i = 8; i < 24; i++)
			{
				PrintF(Monitor, "\n                                ");
			}
		}
		else if(((ch == 's') && (str[5] == 'y') && (str[4] == 'y'))
			||  ((ch == 'h') && (str[5] == 'y') && (str[4] == 'n'))
			||  ((ch == 'c') && (str[5] == 'y') && (str[4] == 'y')))
		{
			for(i = 0; i < 8; i++)
			{
				PrintF(Monitor, "\n        0000000000000000        ");
			}
			for(i = 8; i < 24; i++)
			{
				PrintF(Monitor, "\n                                ");
			}
		}
	}
	else if((str[1] == 'y') && (str[0] == 'y'))
	{
		if     (((ch == 's') && (str[7] == 'y') && (str[6] == 'y'))
			||  ((ch == 'o') && (str[7] == 'y') && (str[6] == 'y'))
			||  ((ch == 't') && (str[7] == 'n') && (str[6] == 'y')))
		{
			for(i = 0; i < 16; i++)
			{
				PrintF(Monitor, "\n                                ");
			}
			for(i = 16; i < 24; i++)
			{
				PrintF(Monitor, "\n00000000                00000000");
			}
		}
		else if(((ch == 'O') && (str[7] == 'n') && (str[6] == 'y'))
			||  ((ch == 'c') && (str[7] == 'n') && (str[6] == 'n') && (str[5] == 'n') && (str[4] == 'n')))
		{
			for(i = 0; i < 16; i++)
			{
				PrintF(Monitor, "\n                                ");
			}
			for(i = 16; i < 24; i++)
			{
				PrintF(Monitor, "\n  00000000            00000000  ");
			}
		}
		else if(((ch == 'o') && (str[7] == 'n') && (str[6] == 'n') && (str[5] == 'n') && (str[4] == 'n'))
			||  ((ch == 'C') && (str[5] == 'y') && (str[4] == 'n')))
		{
			for(i = 0; i < 16; i++)
			{
				PrintF(Monitor, "\n                                ");
			}
			for(i = 16; i < 24; i++)
			{
				PrintF(Monitor, "\n      00000000    00000000      ");
			}
		}
		else if(((ch == 's') && (str[5] == 'y') && (str[4] == 'y'))
			||  ((ch == 'h') && (str[5] == 'y') && (str[4] == 'n'))
			||  ((ch == 'c') && (str[5] == 'y') && (str[4] == 'y')))
		{
			for(i = 0; i < 16; i++)
			{
				PrintF(Monitor, "\n                                ");
			}
			for(i = 16; i < 24; i++)
			{
				PrintF(Monitor, "\n        0000000000000000        ");
			}
		}
	}
	
	return;
}		
