/* UPDN.c */

#include "EV4.h"
#include "UPDN.h"

/*=====================================================================
  ㏸~\֐
  =====================================================================*/
/*
 * Position
 */
void Position(struct Position *this)
{
	/* l */
	this->m_UNSL = OFF;
	this->m_UNST = OFF;
	this->m_UPSL = OFF;
	this->m_UPST = OFF;
	this->p_UnderSlow = &this->m_UNSL;
	this->p_UnderStop = &this->m_UNST;
	this->p_UpperSlow = &this->m_UPSL;
	this->p_UpperStop = &this->m_UPST;
	/* Sleepp */
	this->fstop = OFF;
	this->p_fstop = &this->fstop;
	this->fmove = OFF;
	this->p_fmove = &this->fmove;
	
	/* ߂ */
	return;
}

/*
 * UpMotor
 */
void UpMotor(struct UpMotor *this)
{
	CFile(&this->LF);
	
	/* ߂ */
	return;
}

/*
 * OnUpMotor
 */
/* ㏸ */
void OnUpMotor(struct UpMotor *this, struct Position P)
{
	if(*P.p_UpperStop == ON){
		/* Sleepp */
		if(*P.p_fstop == OFF){
			*P.p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 's');
			PrintF(Panel, "STOP");
		}
	}
	else if(*P.p_UpperSlow == ON){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'u');
			PrintF(Panel, "UP");
		}
	}
	else if(*P.p_UnderSlow == OFF){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'U');
			PrintF(Panel, "UP Speedy");
		}
	}
	else if(*P.p_UnderStop == OFF){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'u');
			PrintF(Panel, "UP");
		}
	}
	else if(*P.p_UnderStop == ON){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'j');
			PrintF(Panel, "UP Start");
		}
	}
	
	/* ߂ */
	return;
}

/*
 * DownMotor
 */
void DownMotor(struct DownMotor *this)
{
	CFile(&this->LF);
	
	/* ߂ */
	return;
}

/*
 * OnDownMotor
 */
/* ~ */
void OnDownMotor(struct DownMotor *this, struct Position P)
{
	if(*P.p_UnderStop == ON){
		/* Sleepp */
		if(*P.p_fstop == OFF){
			*P.p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 's');
			PrintF(Panel, "STOP");
		}
	}
	else if(*P.p_UnderSlow == ON){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'd');
			PrintF(Panel, "DOWN");
		}
	}
	else if(*P.p_UpperSlow == OFF){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'D');
			PrintF(Panel, "DOWN Speedy");
		}
	}
	else if(*P.p_UpperStop == OFF){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'd');
			PrintF(Panel, "DOWN");
		}
	}
	else if(*P.p_UpperStop == ON){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'k');
			PrintF(Panel, "DOWN Start");
		}
	}
	
	/* ߂ */
	return;
}

/*
 * WaitPositionChangeLog
 */
/* Gx[^[̈ʒuzO */
void WaitPositionChangeLog(struct WaitPositionChangeLog *this)
{
	this->p_strLimit = &this->strLimit[0];
	
	/* ߂ */
	return;
}

/*
 * OnInitWaitPositionChangeLog
 */
/* Gx[^[̈ʒuzO */
void OnInitWaitPositionChangeLog(struct WaitPositionChangeLog *this, struct Position *P)
{
	/* ZTl */
	/* ~bgXCb`̓ǂݍ */
	this->p_strLimit = &this->strLimit[0];
	Limit_Read(&this->LF, this->p_strLimit);
	this->tmp = ((this->strLimit[0] == 'y') ? ON : OFF);
	Checkfmove(P->p_UnderStop, P->p_fmove, this->tmp);
	this->tmp = ((this->strLimit[1] == 'y') ? ON : OFF);
	Checkfmove(P->p_UnderSlow, P->p_fmove, this->tmp);
	this->tmp = ((this->strLimit[2] == 'y') ? ON : OFF);
	Checkfmove(P->p_UpperSlow, P->p_fmove, this->tmp);
	this->tmp = ((this->strLimit[3] == 'y') ? ON : OFF);
	Checkfmove(P->p_UpperStop, P->p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * OnWaitUpPositionChangeLog
 */
/* Gx[^[̈ʒuzO */
void OnWaitUpPositionChangeLog(struct WaitPositionChangeLog *this, struct Position *P)
{
	/* ~bgXCb`̓ǂݍ */
	this->p_strLimit = &this->strLimit[0];
	Limit_Read(&this->LF, this->p_strLimit);
	this->tmp = (this->strLimit[0] == 'y') ? ON : OFF;
	Checkfmove(P->p_UnderStop, P->p_fmove, this->tmp);
	this->tmp = (this->strLimit[1] == 'y') ? ON : OFF;
	Checkfmove(P->p_UnderSlow, P->p_fmove, this->tmp);
	this->tmp = (this->strLimit[2] == 'y') ? ON : OFF;
	Checkfmove(P->p_UpperSlow, P->p_fmove, this->tmp);
	this->tmp = (this->strLimit[3] == 'y') ? ON : OFF;
	Checkfmove(P->p_UpperStop, P->p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * OnWaitDownPositionChangeLog
 */
/* Gx[^[̈ʒuzO */
void OnWaitDownPositionChangeLog(struct WaitPositionChangeLog *this, struct Position *P)
{
	/* ~bgXCb`̓ǂݍ */
	this->p_strLimit = &this->strLimit[0];
	Limit_Read(&this->LF, this->p_strLimit);
	this->tmp = (this->strLimit[0] == 'y') ? ON : OFF;
	Checkfmove(P->p_UnderStop, P->p_fmove, this->tmp);
	this->tmp = (this->strLimit[1] == 'y') ? ON : OFF;
	Checkfmove(P->p_UnderSlow, P->p_fmove, this->tmp);
	this->tmp = (this->strLimit[2] == 'y') ? ON : OFF;
	Checkfmove(P->p_UpperSlow, P->p_fmove, this->tmp);
	this->tmp = (this->strLimit[3] == 'y') ? ON : OFF;
	Checkfmove(P->p_UpperStop, P->p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * Up
 */
/* ㏸ */
void Up(struct Position *P, struct UpMotor UPMT, struct WaitPositionChangeLog WPCL, struct Handle_Thread *th)
{
	/* ㏸mFp */
	struct CFile LF;
	
	/* Wait_msp */
	struct CTime T;
	
	/*  */
	CFile(&LF);
	CTime(&T, th);

	/* ܂ */
	if(*P->p_UpperStop == OFF){
		/* ㏸ */
		OnUpMotor(&UPMT, *P);

		/* oߎ */
		/* Sleep */
		Wait_ms(&T, 500);
		
		/* Gx[^[̈ʒuzO */
		OnWaitUpPositionChangeLog(&WPCL, P);
	}
	else if(Motor_Read(&LF) == 's')
	{
		/* ݏK */
		PrintF(Panel, "2nd Floor");
	}
	
	/* ߂ */
	return;
}

/*
 * Down
 */
/* ~ */
void Down(struct Position *P, struct DownMotor DNMT, struct WaitPositionChangeLog WPCL, struct Handle_Thread *th)
{
	/* ~mFp */
	struct CFile LF;
	
	/* Wait_msp */
	struct CTime T;
	
	/*  */
	CFile(&LF);
	CTime(&T, th);

	/* ܂ */
	if(*P->p_UnderStop == OFF){
		/* ~ */
		OnDownMotor(&DNMT, *P);

		/* oߎ */
		/* Sleep */
		Wait_ms(&T, 500);
		
		/* Gx[^[̈ʒuzO */
		OnWaitDownPositionChangeLog(&WPCL, P);
	}
	else if(Motor_Read(&LF) == 's')
	{
		/* ݉K */
		PrintF(Panel, "1st Floor");
	}
	
	/* ߂ */
	return;
}
