//	OpenClose.cpp

#include "EV_Controller.h"
#include "OpenClose.h"

using namespace Time;
using namespace File;
using namespace UpDown;

namespace OpenClose{
	Door::Door(){
		//	l
		m_CLSL = OFF;
		m_CLST = OFF;
		m_OPSL = OFF;
		m_OPST = OFF;
		p_CloserSlow = &m_CLSL;
		p_CloserStop = &m_CLST;
		p_OpennerSlow = &m_OPSL;
		p_OpennerStop = &m_OPST;
		//	Sleepp
		fstop = OFF;
		p_fstop = &fstop;
		fmove = OFF;
		p_fmove = &fmove;
	}

	//	J
	void	OpenMotor::OnOpenMotor(Door DR){
		if(*DR.p_OpennerStop == ON){
			//	Sleepp
			if(*DR.p_fstop == OFF){
				*DR.p_fstop = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('s');
				printf("STOP܂\n");
			}
		}
		else if(*DR.p_OpennerSlow == ON){
			//	Sleepp
			*DR.p_fstop = OFF;
			if(*DR.p_fmove == OFF){
				*DR.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('o');
				printf("OPEN܂\n");
			}
		}
		else if(*DR.p_CloserSlow == OFF){
			//	Sleepp
			*DR.p_fstop = OFF;
			if(*DR.p_fmove == OFF){
				*DR.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('O');
				printf("OPEN܂\n");
			}
		}
		else if(*DR.p_CloserStop == OFF){
			//	Sleepp
			*DR.p_fstop = OFF;
			if(*DR.p_fmove == OFF){
				*DR.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('o');
				printf("OPEN܂\n");
			}
		}
		else if(*DR.p_CloserStop == ON){
			//	Sleepp
			*DR.p_fstop = OFF;
			if(*DR.p_fmove == OFF){
				*DR.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('h');
				printf("J܂\n");
			}
		}

		return;
	}

	//	
	void	CloseMotor::OnCloseMotor(Door DR){
		if(*DR.p_CloserStop == ON){
			//	Sleepp
			if(*DR.p_fstop == OFF){
				*DR.p_fstop = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('s');
				printf("STOP܂\n");
			}
		}
		else if(*DR.p_CloserSlow == ON){
			//	Sleepp
			*DR.p_fstop = OFF;
			if(*DR.p_fmove == OFF){
				*DR.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('c');
				printf("CLOSE܂\n");
			}
		}
		else if(*DR.p_OpennerSlow == OFF){
			//	Sleepp
			*DR.p_fstop = OFF;
			if(*DR.p_fmove == OFF){
				*DR.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('C');
				printf("CLOSE܂\n");
			}
		}
		else if(*DR.p_OpennerStop == OFF){
			//	Sleepp
			*DR.p_fstop = OFF;
			if(*DR.p_fmove == OFF){
				*DR.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('c');
				printf("CLOSE܂\n");
			}
		}
		else if(*DR.p_OpennerStop == ON){
			//	Sleepp
			*DR.p_fstop = OFF;
			if(*DR.p_fmove == OFF){
				*DR.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('t');
				printf("܂\n");
			}
		}

		return;
	}

	//	~
	void	CloseMotor::OnStopCloseMotor(Door DR){
		if(*DR.p_OpennerStop == ON){
			//	Sleepp
			if(*DR.p_fstop == OFF){
				*DR.p_fstop = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('s');
				printf("STOP܂\n");
			}
		}
		else{
			//	Sleepp
			*DR.p_fstop = OFF;
			if(*DR.p_fmove == OFF){
				*DR.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('h');
				printf("J܂\n");
			}
		}
	}


	//	Gx[^[̈ʒuzO
	WaitDoorChangeLog::WaitDoorChangeLog(){
		p_chTurnOpen = &chTurnOpen;
		p_strLimit = &strLimit[0];
	}

	//	Gx[^[̈ʒuzO
	void	WaitDoorChangeLog::OnInitWaitDoorChangeLog(Door DR){
		//	ZTl
		//	~bgXCb`̓ǂݍ
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
		tmp = (strLimit[4] == 'y') ? ON : OFF;
		Checkfmove(DR.p_CloserStop, DR.p_fmove, tmp);
		tmp = (strLimit[5] == 'y') ? ON : OFF;
		Checkfmove(DR.p_CloserSlow, DR.p_fmove, tmp);
		tmp = (strLimit[6] == 'y') ? ON : OFF;
		Checkfmove(DR.p_OpennerSlow, DR.p_fmove, tmp);
		tmp = (strLimit[7] == 'y') ? ON : OFF;
		Checkfmove(DR.p_OpennerStop, DR.p_fmove, tmp);
	}

	//	Gx[^[̈ʒuzO
	void	WaitDoorChangeLog::OnWaitOpenDoorChangeLog(Door DR){
		//	~bgXCb`̓ǂݍ
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
		tmp = (strLimit[4] == 'y') ? ON : OFF;
		Checkfmove(DR.p_CloserStop, DR.p_fmove, tmp);
		tmp = (strLimit[5] == 'y') ? ON : OFF;
		Checkfmove(DR.p_CloserSlow, DR.p_fmove, tmp);
		tmp = (strLimit[6] == 'y') ? ON : OFF;
		Checkfmove(DR.p_OpennerSlow, DR.p_fmove, tmp);
		tmp = (strLimit[7] == 'y') ? ON : OFF;
		Checkfmove(DR.p_OpennerStop, DR.p_fmove, tmp);
	}

	//	J
	void	Open(Door DR , OpenMotor OPMT ,
				WaitDoorChangeLog WDCL , CTimeOut *p_OpenTO){
		//	JmFp
		CLimitFile		LF;

		//	܂
		while((*DR.p_OpennerStop == OFF)
			|| (LF.Motor_Read() != 's')){
			//	J
			OPMT.OnOpenMotor(DR);

			//	oߎ
			//	Sleep
			Wait_ms(500);
			
			//	Gx[^[̈ʒuzO
			WDCL.OnWaitOpenDoorChangeLog(DR);
		}
		//	݊J
		printf("JĂ܂\n");
		p_OpenTO->SetCurrentTime();
		p_OpenTO->SetPermit(ON);

		//	߂
		return;
	}

	//	Gx[^[̈ʒuzO
	void	WaitDoorChangeLog::OnWaitCloseDoorChangeLog(Door DR){
		//	~bgXCb`̓ǂݍ
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
		tmp = (strLimit[4] == 'y') ? ON : OFF;
		Checkfmove(DR.p_CloserStop, DR.p_fmove, tmp);
		tmp = (strLimit[5] == 'y') ? ON : OFF;
		Checkfmove(DR.p_CloserSlow, DR.p_fmove, tmp);
		tmp = (strLimit[6] == 'y') ? ON : OFF;
		Checkfmove(DR.p_OpennerSlow, DR.p_fmove, tmp);
		tmp = (strLimit[7] == 'y') ? ON : OFF;
		Checkfmove(DR.p_OpennerStop, DR.p_fmove, tmp);
	}

    //	TurnOpenmF
	void	WaitDoorChangeLog::OnCheckTurnOpen
		(Position P , Door DR , int *p_TurnOpen){
		
		//	f
		if(TOF.TurnOpen_Read(p_chTurnOpen) == NG) exit(1);
	
		if(*p_chTurnOpen == 'o'){
	//		printf("]J܂\n");
			tmp = ON;
		}
		else if(*p_chTurnOpen == 'Y'){
			if(*P.p_UpperStop == ON){
	//		printf("]J܂\n");
				tmp = ON;
			}
			else{
				printf("Ă͉̊Kɂ܂\n");
				if(TOF.TurnOpen_Write('N') == NG) exit(1);
				tmp = OFF;
			}
		}
		else if(*p_chTurnOpen == 'y'){
			if(*P.p_UnderStop == ON){
	//			printf("]J܂\n");
				tmp = ON;
			}
			else{
				printf("Ă͏̊Kɂ܂\n");
				if(TOF.TurnOpen_Write('N') == NG) exit(1);
				tmp = OFF;
			}
		}
		else{
			tmp = OFF;
		}
		
		Checkfmove(p_TurnOpen, DR.p_fmove, tmp);
	}

	//	
	void	Close(Position P , Door DR , CloseMotor CLMT ,
				int *p_TurnOpen , OpenMotor OPMT ,
				WaitDoorChangeLog WDCL , CTimeOut *p_OpenTO){
		//	Whilep
		int		WhileFlag = ON;

		//	fp
		CTurnOpenFile	TOF;

		//	mFp
		CLimitFile		LF;

		//	f
		if(TOF.PermitTurnOpen_Write('o') == NG) exit(1);

		//	While𔲂o
		if(*DR.p_CloserStop == ON){
			WhileFlag = OFF;
		}
		
		//	܂
		while(WhileFlag == ON){
			//	
			CLMT.OnCloseMotor(DR);

			//	oߎ
			//	Sleep
			Wait_ms(500);
			
			//	Gx[^[̈ʒuzO
			WDCL.OnWaitCloseDoorChangeLog(DR);

	    	//	TurnOpenmF
	    	WDCL.OnCheckTurnOpen(P , DR , p_TurnOpen);
				
			//	f
			if(*p_TurnOpen == ON){
				//	~
				CLMT.OnStopCloseMotor(DR);
				//	J
				Open(DR,OPMT,WDCL,p_OpenTO);
				//	sWhile𔲂o
				WhileFlag = OFF;
			}
			else if(*p_TurnOpen == OFF){
				if(*DR.p_CloserStop == OFF){
					WhileFlag = ON;
				}
				//	While𔲂o
				else if((*DR.p_CloserStop == ON)
					&& (LF.Motor_Read() == 's')){
					WhileFlag = OFF;
				}
			}
		}
		//	sȊO
		if(*p_TurnOpen == OFF){
			//	ݕ
			printf("Ă܂\n");
		}

		//	fI
		if(TOF.PermitTurnOpen_Write('N') == NG) exit(1);

		//	fI
		if(TOF.TurnOpen_Write('N') == NG) exit(1);

		//	߂
		return;
	}
}
