//	OpenClose.h
/*
#ifndef Time_h
#define Time_h
#include "Time.h"
#endif

#ifndef File_h
#define File_h
#include "File.h"
#endif
*/
#ifndef UpDown_h
#define UpDown_h
#include "UpDown.h"
#endif

using namespace Time;
using namespace File;
using namespace UpDown;

namespace OpenClose{
	//	Gx[^[݈̌ʒu
	class	Door{
		int		m_CLSL;
		int		m_CLST;
		int		m_OPSL;
		int		m_OPST;
	public:
		//	ʒu
		int		*p_CloserSlow;
		//	~ʒu
		int		*p_CloserStop;
		//	Jʒu
		int		*p_OpennerSlow;
		//	J~ʒu
		int		*p_OpennerStop;
		//	Sleepp
		int		fstop;
		int		*p_fstop;
		int		fmove;
		int		*p_fmove;
		Door();
	};

	//	J
	class	OpenMotor{
		CLimitFile	LF;
	public:
		//	J
		void	OnOpenMotor(Door DR);
	};

	//	
	class	CloseMotor{
		CLimitFile	LF;
	public:
		//	
		void	OnCloseMotor(Door DR);
		//	~
		void	OnStopCloseMotor(Door DR);
	};

	//	Gx[^[̈ʒuzO
	class	WaitDoorChangeLog{
		CTurnOpenFile	TOF;
		char	chTurnOpen;
		char	*p_chTurnOpen;
		CLimitFile	LF;
		char	strLimit[9];
		char	*p_strLimit;
		//	Sleepp
		int		tmp;
	public:
		WaitDoorChangeLog();
		//	oߎ
		void	OnInitWaitDoorChangeLog(Door DR);
		void	OnWaitOpenDoorChangeLog(Door DR);
		void	OnWaitCloseDoorChangeLog(Door DR);
		//	TurnOpenmF
		void	OnCheckTurnOpen(Position P , Door DR , int *p_TurnOpen);
	};

	//	J
	void	Open(Door DR , OpenMotor OPMT ,
				WaitDoorChangeLog WDCL , CTimeOut *p_OpenTO);

	//	
	void	Close(Position P , Door DR , CloseMotor CLMT ,
				int *p_TurnOpen , OpenMotor OPMT ,
				WaitDoorChangeLog WDCL , CTimeOut *p_OpenTO);
}
