//	File.cpp

#include "EV_Controller.h"
#include "File.h"

using namespace Time;

namespace File{
	//	
	int CFile::Write(char *filename, char ch){
		if((fp = fopen(filename, "w")) == NULL){
			return	NG;
		}
		else if(fputc(ch, fp) == ch){
			fclose(fp);
			//	ݐ
			return	OK;
		}
		else{
			fclose(fp);
			//	ݎs
			return	NG;
		}
	}

	/* 񏑂 */
	int CFile::WriteString(char *filename, char *str){
		if((this->fp = fopen(filename, "w")) == NULL){
			return	NG;
		}
		/* \n͒ǋLȂ */
		else if(fputs(str, this->fp) >= 0){
			fclose(this->fp);
			/* ݐ */
			return	OK;
		}
		else{
			fclose(this->fp);
			/* ݎs */
			return	NG;
		}
	}

	//	ǂݍ
	int CFile::Read(char *filename, char *p_ch){
		if((fp = fopen(filename, "r")) == NULL){
			return NG;
		}
		else if((*p_ch = fgetc(fp)) == EOF){
			fclose(fp);
			//	ǂݍݎs
			return ONE_MORE_TIME;
		}
		else if(*p_ch == '\n'){
			fclose(fp);
			//	s͂܂
			return ONE_MORE_TIME;
		}
		else if(*p_ch == 'N'){
			fclose(fp);
			//	M͂܂
			return ONE_MORE_TIME;
		}
		else{
			fclose(fp);
			//	̑̓ǂݍݒl
			return OK;
		}
	}

	//	ǂݍ
	int CFile::ReadString(char *filename, char *str, int strlength){
		if((fp = fopen(filename, "r")) == NULL){
			return NG;
		}
		else if(fgets(str, strlength, fp) == NULL){
			fclose(fp);
			//	ǂݍݎs
			return ONE_MORE_TIME;
		}
		else if(str[0] == '\n'){
			fclose(fp);
			//	s͂܂
			return ONE_MORE_TIME;
		}
		else if(str[0] == 'N'){
			fclose(fp);
			//	M͂܂
			return ONE_MORE_TIME;
		}
		else{
			fclose(fp);
			//	̑̓ǂݍݒl
			return OK;
		}
	}

	//	ߓ͋
	//	ߓ͋I
	int CCommandFile::PermitCommand_Write(char PermitCommand){
		int Ret = ONE_MORE_TIME;
		switch(Write("PermitCommand.txt\0", PermitCommand)){
		case NG:
			printf("PermitCommand.txt֏ݎs\n");
			T.WaitSecond(5);
			Ret = NG;
			break;
		case OK:
			//	printf("ݐ");
			Ret = OK;
			break;
		default:
			//	_~[
			Ret = NG;
			break;
		}
		return Ret;
	}

	//	ߓ
	int CCommandFile::Command_Read(char *p_Command){
		int Ret = ONE_MORE_TIME;
		switch(Read("Command.txt\0", p_Command)){
		case NG:
			printf("Command.txtJ܂\n");
			T.WaitSecond(5);
			Ret = NG;
			break;
		case ONE_MORE_TIME:
			//	ǂݍݎs܂͉s͂܂
			T.WaitSecond(1);
			Ret = ONE_MORE_TIME;
			break;
		default:
			//	̑̓ǂݍݒl
			Ret = OK;
			break;
		}
		return Ret;
	}

	//	ߓ͎I
	int CCommandFile::Command_Write(char Command){
		int Ret = ONE_MORE_TIME;
		switch(Write("Command.txt\0", Command)){
		case NG:
			printf("Command.txt|ł܂\n");
			T.WaitSecond(5);
			Ret = NG;
			break;
		case OK:
			//	printf("|܂\n");
			Ret = OK;
			break;
		default:
			//	_~[
			Ret = NG;
			break;
		}
		return Ret;
	}

	//	]J
	//	]JI
	int CTurnOpenFile::PermitTurnOpen_Write(char PermitTurnOpen){
		int Ret = ONE_MORE_TIME;
		switch(Write("PermitTurnOpen.txt\0", PermitTurnOpen)){
		case NG:
			printf("PermitTurnOpen.txt֏ݎs\n");
			T.WaitSecond(5);
			Ret = NG;
			break;
		case OK:
			//	printf("ݐ");
			Ret = OK;
			break;
		default:
			//	_~[
			Ret = NG;
			break;
		}
		return Ret;
	}

	//	]J
	int CTurnOpenFile::TurnOpen_Read(char *p_chTurnOpen){
		int Ret = ONE_MORE_TIME;
		switch(Read("TurnOpen.txt\0", p_chTurnOpen)){
		case NG:
			printf("TurnOpen.txtJ܂\n");
			T.WaitSecond(5);
			Ret = NG;
			break;
		case ONE_MORE_TIME:
			//	ǂݍݎs܂͉s͂܂
			T.WaitSecond(1);
			Ret = ONE_MORE_TIME;
			break;
		default:
			//	̑̓ǂݍݒl
			Ret = OK;
			break;
		}
		return Ret;
	}

	//	]JI
	int CTurnOpenFile::TurnOpen_Write(char TurnOpen){
		int Ret = ONE_MORE_TIME;
		switch(Write("TurnOpen.txt\0", TurnOpen)){
		case NG:
			printf("TurnOpen.txt|ł܂\n");
			T.WaitSecond(5);
			Ret = NG;
			break;
		case OK:
			//	printf("|܂\n");
			Ret = OK;
			break;
		default:
			//	_~[
			Ret = NG;
			break;
		}
		return Ret;
	}

	//	݂̏Ԃ̕
	void CLimitFile::Motor_Write(char Motor){
		int Ret = ONE_MORE_TIME;
		switch(Write("Motor.txt\0", Motor)){
		case NG:
			printf("Motor.txt֏ݎs\n");
			T.WaitSecond(5);
			Ret = NG;
			break;
		case OK:
			//	printf("ݐ");
			Ret = OK;
			break;
		default:
			//	_~[
			Ret = NG;
			break;
		}
		if(Ret == NG){
			exit(1);
		}
		return;
	}

	//	ǂݍ
	char CLimitFile::Motor_Read(){
		char Ret = '\0';
		char ch;
		char *p_ch;
		ch = '\0';
		p_ch = &ch;

		switch(Read("Motor.txt\0", p_ch)){
		case NG:
			Ret = 'q';
			break;
		//	ǂݍݎs
		case ONE_MORE_TIME:
			Ret = '\0';
			break;
		//	̑̓ǂݍݒl
		case OK:
			Ret = ch;
			break;
		//	_~[
		default:
			Ret = 'q';
			break;
		}
		if(Ret == 'q'){
			exit(1);
		}
		return Ret;
	}

	//	~bgXCb`̓ǂݍ
	void CLimitFile::Limit_Read(char *str){
		int Ret = ONE_MORE_TIME;
		//	((tA - 2) * 6) + (̖̑ߌ꒷12 + '\0' == 13) == (tA * 6) + 1
		//	((FLOOR) * 6) + 1 == LIMIT
		switch(ReadString("Limit.txt\0", str, LIMIT)){
		case NG:
			printf("Limit.txtJ܂\n");
			T.WaitSecond(5);
			Ret = NG;
			break;
		case ONE_MORE_TIME:
			//	ǂݍݎs܂͉s͂܂
			//	printf("ǂݍݎs܂͉s͂܂");
			//	T.WaitSecond(1);
			Ret = ONE_MORE_TIME;
			break;
		default:
			//	̑̓ǂݍݒl
			Ret = ONE_MORE_TIME;
			break;
		}
		if(Ret == NG){
			exit(1);
		}
		return;
	}
}
