//	OpenClose.cpp

#include "EV_Controller.h"
#include "OpenClose.h"

using namespace Time;
using namespace File;
using namespace UpDown;

namespace OpenClose{
	Door::Door(){
		//	l
		m_CLSL = OFF;
		m_CLST = OFF;
		m_OPSL = OFF;
		m_OPST = OFF;
		p_CloserSlow = &m_CLSL;
		p_CloserStop = &m_CLST;
		p_OpennerSlow = &m_OPSL;
		p_OpennerStop = &m_OPST;
		//	Sleepp
		fstop = OFF;
		p_fstop = &fstop;
		fmove = OFF;
		p_fmove = &fmove;
	}

	//	J
	void OpenMotor::OnOpenMotor(Door *p_DR){
		if(*p_DR->p_OpennerStop == ON){
			//	Sleepp
			if(*p_DR->p_fstop == OFF){
				*p_DR->p_fstop = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('s');
				printf("STOP܂\n");
			}
		}
		else if(*p_DR->p_OpennerSlow == ON){
			//	Sleepp
			*p_DR->p_fstop = OFF;
			if(*p_DR->p_fmove == OFF){
				*p_DR->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('o');
				printf("OPEN܂\n");
			}
		}
		else if(*p_DR->p_CloserSlow == OFF){
			//	Sleepp
			*p_DR->p_fstop = OFF;
			if(*p_DR->p_fmove == OFF){
				*p_DR->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('O');
				printf("OPEN܂\n");
			}
		}
		else if(*p_DR->p_CloserStop == OFF){
			//	Sleepp
			*p_DR->p_fstop = OFF;
			if(*p_DR->p_fmove == OFF){
				*p_DR->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('o');
				printf("OPEN܂\n");
			}
		}
		else if(*p_DR->p_CloserStop == ON){
			//	Sleepp
			*p_DR->p_fstop = OFF;
			if(*p_DR->p_fmove == OFF){
				*p_DR->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('h');
				printf("J܂\n");
			}
		}

		return;
	}

	//	
	void CloseMotor::OnCloseMotor(Door *p_DR){
		if(*p_DR->p_CloserStop == ON){
			//	Sleepp
			if(*p_DR->p_fstop == OFF){
				*p_DR->p_fstop = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('s');
				printf("STOP܂\n");
			}
		}
		else if(*p_DR->p_CloserSlow == ON){
			//	Sleepp
			*p_DR->p_fstop = OFF;
			if(*p_DR->p_fmove == OFF){
				*p_DR->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('c');
				printf("CLOSE܂\n");
			}
		}
		else if(*p_DR->p_OpennerSlow == OFF){
			//	Sleepp
			*p_DR->p_fstop = OFF;
			if(*p_DR->p_fmove == OFF){
				*p_DR->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('C');
				printf("CLOSE܂\n");
			}
		}
		else if(*p_DR->p_OpennerStop == OFF){
			//	Sleepp
			*p_DR->p_fstop = OFF;
			if(*p_DR->p_fmove == OFF){
				*p_DR->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('c');
				printf("CLOSE܂\n");
			}
		}
		else if(*p_DR->p_OpennerStop == ON){
			//	Sleepp
			*p_DR->p_fstop = OFF;
			if(*p_DR->p_fmove == OFF){
				*p_DR->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('t');
				printf("܂\n");
			}
		}

		return;
	}

	//	~
	void CloseMotor::OnStopCloseMotor(Door *p_DR){
		if(*p_DR->p_OpennerStop == ON){
			//	Sleepp
			if(*p_DR->p_fstop == OFF){
				*p_DR->p_fstop = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('s');
				printf("STOP܂\n");
			}
		}
		else{
			//	Sleepp
			*p_DR->p_fstop = OFF;
			if(*p_DR->p_fmove == OFF){
				*p_DR->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('h');
				printf("J܂\n");
			}
		}
	}


	//	Gx[^[̈ʒuzO
	WaitDoorChangeLog::WaitDoorChangeLog(){
		p_chTurnOpen = &chTurnOpen;
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
	}

	//	Gx[^[̈ʒuzO
	void WaitDoorChangeLog::OnInitWaitDoorChangeLog(Door *p_DR){
		//	ZTl
		//	~bgXCb`̓ǂݍ
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
		tmp = (strLimit[4] == 'y') ? ON : OFF;
		Checkfmove(p_DR->p_CloserStop, p_DR->p_fmove, tmp);
		tmp = (strLimit[5] == 'y') ? ON : OFF;
		Checkfmove(p_DR->p_CloserSlow, p_DR->p_fmove, tmp);
		tmp = (strLimit[6] == 'y') ? ON : OFF;
		Checkfmove(p_DR->p_OpennerSlow, p_DR->p_fmove, tmp);
		tmp = (strLimit[7] == 'y') ? ON : OFF;
		Checkfmove(p_DR->p_OpennerStop, p_DR->p_fmove, tmp);
	}

	//	Gx[^[̈ʒuzO
	void WaitDoorChangeLog::OnWaitOpenDoorChangeLog(Door *p_DR){
		//	~bgXCb`̓ǂݍ
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
		tmp = (strLimit[4] == 'y') ? ON : OFF;
		Checkfmove(p_DR->p_CloserStop, p_DR->p_fmove, tmp);
		tmp = (strLimit[5] == 'y') ? ON : OFF;
		Checkfmove(p_DR->p_CloserSlow, p_DR->p_fmove, tmp);
		tmp = (strLimit[6] == 'y') ? ON : OFF;
		Checkfmove(p_DR->p_OpennerSlow, p_DR->p_fmove, tmp);
		tmp = (strLimit[7] == 'y') ? ON : OFF;
		Checkfmove(p_DR->p_OpennerStop, p_DR->p_fmove, tmp);
	}

	void COpenClose::InitOpenClose(Door *p_dr)
	{
		p_DR = p_dr;
		p_OPMT = &OPMT;
		p_CLMT = &CLMT;
		p_WDCL = &WDCL;
		//	Gx[^[̈ʒuzO
		//	l
		p_WDCL->OnInitWaitDoorChangeLog(p_DR);
	}

	//	J
	int	COpenClose::Open(CTimeOut *p_OpenTO){
		//	JmFp
		CLimitFile LF;

		//	J^CAEgp
		CTime OTO;

		//	J^CAEgJEgJn
		OTO.SetCurrentTime();

		//	܂
		while((*p_DR->p_OpennerStop == OFF)
			|| (LF.Motor_Read() != 's')){
			//	J
			p_OPMT->OnOpenMotor(p_DR);

			//	J^CAEgJEg
			if(OTO.GetCurrentTime() >= DOORTIMEOUT){
				printf("Jԃ^CAEg\n");
				LF.Motor_Write('s');
				*p_DR->p_fstop = OFF;
				*p_DR->p_fmove = OFF;
				return NG;
			}

			//	oߎ
			//	Sleep
			Wait_ms(500);

			//	Gx[^[̈ʒuzO
			p_WDCL->OnWaitOpenDoorChangeLog(p_DR);
		}
		//	݊J
		printf("JĂ܂\n");
		p_OpenTO->SetCurrentTime();
		p_OpenTO->SetPermit(ON);

		//	߂
		return OK;
	}

	//	Gx[^[̈ʒuzO
	void WaitDoorChangeLog::OnWaitCloseDoorChangeLog(Door *p_DR){
		//	~bgXCb`̓ǂݍ
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
		tmp = (strLimit[4] == 'y') ? ON : OFF;
		Checkfmove(p_DR->p_CloserStop, p_DR->p_fmove, tmp);
		tmp = (strLimit[5] == 'y') ? ON : OFF;
		Checkfmove(p_DR->p_CloserSlow, p_DR->p_fmove, tmp);
		tmp = (strLimit[6] == 'y') ? ON : OFF;
		Checkfmove(p_DR->p_OpennerSlow, p_DR->p_fmove, tmp);
		tmp = (strLimit[7] == 'y') ? ON : OFF;
		Checkfmove(p_DR->p_OpennerStop, p_DR->p_fmove, tmp);
	}

    //	TurnOpenmF
	void WaitDoorChangeLog::OnCheckTurnOpen
		(Position *p_P, Door *p_DR, int *p_TurnOpen){
		
		//	f
		if(TOF.TurnOpen_Read(p_chTurnOpen) == NG) exit(1);
	
		if(*p_chTurnOpen == 'o'){
			//	printf("]J܂\n");
			tmp = ON;
		}
		else if(*p_chTurnOpen == 'Y'){
			if(*p_P->p_UpperStop == ON){
				//	printf("]J܂\n");
				tmp = ON;
			}
			else{
				printf("Ă͉̊Kɂ܂\n");
				if(TOF.TurnOpen_Write('N') == NG) exit(1);
				tmp = OFF;
			}
		}
		else if(*p_chTurnOpen == 'y'){
			if(*p_P->p_UnderStop == ON){
				//	printf("]J܂\n");
				tmp = ON;
			}
			else{
				printf("Ă͏̊Kɂ܂\n");
				if(TOF.TurnOpen_Write('N') == NG) exit(1);
				tmp = OFF;
			}
		}
		else{
			tmp = OFF;
		}
		
		Checkfmove(p_TurnOpen, p_DR->p_fmove, tmp);
	}

	//	
	int	COpenClose::Close(Position *p_P, int *p_TurnOpen, CTimeOut *p_OpenTO){
		//	Whilep
		int WhileFlag = ON;

		//	fp
		CTurnOpenFile	TOF;

		//	mFp
		CLimitFile LF;

		//	^CAEgp
		CTime CTO;

		//	nkp
		CFile CF;
		char ch;
		char *p_ch;

		//	^CAEgJEgJn
		CTO.SetCurrentTime();

		//	nkp
		p_ch = &ch;

		//	f
		if(TOF.PermitTurnOpen_Write('o') == NG) exit(1);

		//	While𔲂o
		if(*p_DR->p_CloserStop == ON){
			WhileFlag = OFF;
		}
		
		//	܂
		while(WhileFlag == ON){
			//	
			p_CLMT->OnCloseMotor(p_DR);

			//	^CAEgJEg
			if(CTO.GetCurrentTime() >= DOORTIMEOUT){
				printf("ԃ^CAEg\n");
				LF.Motor_Write('s');
				*p_DR->p_fstop = OFF;
				*p_DR->p_fmove = OFF;
				return NG;
			}

			//	oߎ
			//	Sleep
			Wait_ms(500);

			//	nkp
			CF.Read("Earthquake.txt", p_ch);
			if(ch == 'e'){
				printf("nkɂJ܂\n");
				CF.Write("Earthquake.txt", 'N');
				TOF.TurnOpen_Write('o');
			}

			//	Gx[^[̈ʒuzO
			p_WDCL->OnWaitCloseDoorChangeLog(p_DR);

	    	//	TurnOpenmF
	    	p_WDCL->OnCheckTurnOpen(p_P, p_DR, p_TurnOpen);
				
			//	f
			if(*p_TurnOpen == ON){
				//	~
				p_CLMT->OnStopCloseMotor(p_DR);
				//	J
				Open(p_OpenTO);
				//	sWhile𔲂o
				WhileFlag = OFF;
			}
			else if(*p_TurnOpen == OFF){
				if(*p_DR->p_CloserStop == OFF){
					WhileFlag = ON;
				}
				//	While𔲂o
				else if((*p_DR->p_CloserStop == ON)
					&& (LF.Motor_Read() == 's')){
					WhileFlag = OFF;
				}
			}
		}
		//	sȊO
		if(*p_TurnOpen == OFF){
			//	ݕ
			printf("Ă܂\n");
		}

		//	fI
		if(TOF.PermitTurnOpen_Write('N') == NG) exit(1);

		//	fI
		if(TOF.TurnOpen_Write('N') == NG) exit(1);

		//	߂
		return OK;
	}
}
