//	Queue.h

#ifndef Time_h
#define Time_h
#include "Time.h"
#endif

#ifndef File_h
#define File_h
#include "File.h"
#endif

#ifndef UpDown_h
#define UpDown_h
#include "UpDown.h"
#endif

#ifndef OpenClose_h
#define OpenClose_h
#include "OpenClose.h"
#endif

using namespace Time;
using namespace File;
using namespace UpDown;
using namespace OpenClose;

namespace Queue{
	class CQueue{
	public:
		CTime T;
		CFile F;
		char strQueue[33];
		char *p_strQueue;
		char strLimit[LIMIT];
		char *p_strLimit;
		char chMotor;
		char *p_chMotor;
		char *p_UserCommand;
		CTimeOut *p_tOpenTO;
		char UD;
		void Init(void);
		void Write(char *filename, char *p_str, char mode);
		int Command_Read(char *p_Command);
		int CheckTurnOpen(void);
		int Read(char *p_check);
		int Check(char *c0, char *c1, char *c2, char *c3, char *c4, char *c5, char *c6, char *c7, char *c8, char *c9, char *c10, char *c11);
		int Flow(void);
		void Motor(CTimeOut *p_OpenTO);
		void OTOUDChenge(CTimeOut *p_OpenTO);
	};
}
