//	EV_Door.java

import java.util.*;
import javax.swing.*;

public class EV_Door extends JPanel
{
	boolean m_CLSL;
	boolean m_CLST;
	boolean m_OPSL;
	boolean m_OPST;
	boolean m_TurnOpen;
	String m_strLimit;
	
	public EV_Door()
	{
		//	l
		m_CLSL = false;
		m_CLST = false;
		m_OPSL = false;
		m_OPST = false;
		m_TurnOpen = false;
		OnWaitDoorChangeLog();
	}
	
	public boolean getCLSL()
	{
		return m_CLSL;
	}
	
	public boolean getCLST()
	{
		return m_CLST;
	}
	
	public boolean getOPSL()
	{
		return m_OPSL;
	}
	
	public boolean getOPST()
	{
		return m_OPST;
	}
	
	public boolean getTurnOpen()
	{
		return m_TurnOpen;
	}
	
	public void setTurnOpen(boolean t)
	{
		m_TurnOpen = t;
	}
	
	public String getLimit()
	{
		return m_strLimit;
	}
	
	//	J
	void OnOpenMotor()
	{
		if(m_OPST == true)
		{
			//	ݎs̖߂Oɕ
			EV_JFile.Write('s', "Motor.txt");
			EV_JPrint.PrintLn("STOP܂");
		}
		else if(m_OPSL == true)
		{
			//	ݎs̖߂Oɕ
			EV_JFile.Write('o', "Motor.txt");
			EV_JPrint.PrintLn("OPEN܂");
		}
		else if(m_CLSL == false)
		{
			//	ݎs̖߂Oɕ
			EV_JFile.Write('O', "Motor.txt");
			EV_JPrint.PrintLn("OPEN܂");
		}
		else if(m_CLST == false)
		{
			//	ݎs̖߂Oɕ
			EV_JFile.Write('o', "Motor.txt");
			EV_JPrint.PrintLn("OPEN܂");
		}
		else if(m_CLST == true)
		{
			//	ݎs̖߂Oɕ
			EV_JFile.Write('h', "Motor.txt");
			EV_JPrint.PrintLn("J܂");
		}
		
		return;
	}
	
	//	
	void OnCloseMotor()
	{
		if(m_CLST == true)
		{
			//	ݎs̖߂Oɕ
			EV_JFile.Write('s', "Motor.txt");
			EV_JPrint.PrintLn("STOP܂");
		}
		else if(m_CLSL == true)
		{
			//	ݎs̖߂Oɕ
			EV_JFile.Write('c', "Motor.txt");
			EV_JPrint.PrintLn("CLOSE܂");
		}
		else if(m_OPSL == false)
		{
			//	ݎs̖߂Oɕ
			EV_JFile.Write('C', "Motor.txt");
			EV_JPrint.PrintLn("CLOSE܂");
		}
		else if(m_OPST == false)
		{
			//	ݎs̖߂Oɕ
			EV_JFile.Write('c', "Motor.txt");
			EV_JPrint.PrintLn("CLOSE܂");
		}
		else if(m_OPST == true)
		{
			//	ݎs̖߂Oɕ
			EV_JFile.Write('t', "Motor.txt");
			EV_JPrint.PrintLn("܂");
		}
		
		return;
	}
	
	//	~
	void OnStopCloseMotor()
	{
		if(m_OPST == true){
			//	ݎs̖߂Oɕ
			EV_JFile.Write('s', "Motor.txt");
			EV_JPrint.PrintLn("STOP܂");
		}
		else{
			//	ݎs̖߂Oɕ
			EV_JFile.Write('h', "Motor.txt");
			EV_JPrint.PrintLn("J܂");
		}
	}
	
	//	Gx[^[̈ʒuzO
	void OnWaitDoorChangeLog(){
		//	ZTl
		//	~bgXCb`̓ǂݍ
		m_strLimit = EV_JFile.Read(m_strLimit, "Limit.txt");
		m_CLST = ((m_strLimit.charAt(4) == 'y') ? true : false);
		m_CLSL = ((m_strLimit.charAt(5) == 'y') ? true : false);
		m_OPSL = ((m_strLimit.charAt(6) == 'y') ? true : false);
		m_OPST = ((m_strLimit.charAt(7) == 'y') ? true : false);
	}
	
	//	J
	public void Open()
	{
		//	܂
		while((m_OPST == false)
			|| (EV_JFile.Read('s', "Motor.txt") != 's')){
			//	J
			OnOpenMotor();
			
			//	oߎ
			try{
				//	Sleep
				Thread.sleep(500);
			}catch(Exception e){}
			
			//	Gx[^[̈ʒuzO
			OnWaitDoorChangeLog();
		}
		//	݊J
		EV_JPrint.PrintLn("JĂ܂");
		
		//	^CAEgvJn
		EV_JFile.Write('w', "OpenTimeOut.txt");
		
		//	߂
		return;
	}
	
  // TurnOpenmF
	void OnCheckTurnOpen(EV_Position P)
	{
		char chTurnOpen;
		chTurnOpen = 'N';
		
		//	f
		chTurnOpen = EV_JFile.Read(chTurnOpen, "TurnOpen.txt");
		
		if(chTurnOpen == 'o')
		{
			// EV_JPrint.PrintLn("]J܂\n");
			m_TurnOpen = true;
		}
		else if(chTurnOpen == 'Y')
		{
			if(P.getUPST() == true)
			{
				// EV_JPrint.PrintLn("]J܂\n");
				m_TurnOpen = true;
			}
			else{
				EV_JPrint.PrintLn("Ă͉̊Kɂ܂\n");
				EV_JFile.Write('N', "TurnOpen.txt");
				m_TurnOpen = false;
			}
		}
		else if(chTurnOpen == 'y'){
			if(P.getUNST() == true){
				// EV_JPrint.PrintLn("]J܂\n");
				m_TurnOpen = true;
			}
			else{
				EV_JPrint.PrintLn("Ă͏̊Kɂ܂\n");
				EV_JFile.Write('N', "TurnOpen.txt");
				m_TurnOpen = false;
			}
		}
		else{
			m_TurnOpen = false;
		}
	}
	
	//	
	public void Close(EV_Position P)
	{
		//	^CAEgn
		EV_JFile.Write('N', "OpenTimeOut.txt");
			
		//	Whilep
		boolean WhileFlag = true;
		
		//	f
		EV_JFile.Write('o', "PermitTurnOpen.txt");
		
		//	While𔲂o
		if(m_CLST == true){
			WhileFlag = false;
		}
		
		//	܂
		while(WhileFlag == true)
		{
			//	
			OnCloseMotor();
			
			//	oߎ
			try{
				//	Sleep
				Thread.sleep(500);
			}catch(Exception e){}
			
			//	Gx[^[̈ʒuzO
			OnWaitDoorChangeLog();
			
	    //	TurnOpenmF
	    OnCheckTurnOpen(P);
			
			//	f
			if(m_TurnOpen == true){
				//	~
				OnStopCloseMotor();
				//	J
				Open();
				//	sWhile𔲂o
				WhileFlag = false;
			}
			else if(m_TurnOpen == false){
				if(m_CLST == false){
					WhileFlag = true;
				}
				//	While𔲂o
				else if((m_CLST == true)
					&& (EV_JFile.Read('s', "Motor.txt") == 's')){
					WhileFlag = false;
				}
			}
		}
		//	sȊO
		if(m_TurnOpen == false)
		{
			//	ݕ
			EV_JPrint.PrintLn("Ă܂");
		}
		
		//	fI
		EV_JFile.Write('N', "PermitTurnOpen.txt");
		
		//	fI
		EV_JFile.Write('N', "TurnOpen.txt");
		
		//	߂
		return;
	}
}
