import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class EV_Simulator_Display extends JPanel implements Runnable
{
	int L_x;
	int R_x;
	int y;
	int width;
	int height;
	char Safety;
	char Motor;
	String Limit;
	char PermitTurnOpen;
	char TurnOpen;
	
	public EV_Simulator_Display()
	{
		width = 460;
		height = 550;
		Safety();
		Limit();
		PermitTurnOpen = 'N';
		TurnOpen = 'N';
		
		addMouseListener(new MouseAdapter()
		{
			//	 void^ }EX̃NbNɔ
			public void mouseClicked(MouseEvent e)
			{
				if((e.getX() > L_x + 60) && (e.getX() < R_x)
					&& (e.getY() > y) && (e.getY() < y + 120))
				{
					ReadPermitTurnOpen();
					if(PermitTurnOpen == 'o')
					{
						TurnOpen = 'o';
						WriteTurnOpen();
					}
				}
				
				PermitTurnOpen = 'N';
				TurnOpen = 'N';
			}
		});
	}
	private void Safety()
	{
		try{
			while(true)
			{
				ReadSafety();
				if(Safety == 'r') break;
				else if(Safety == 'Y'){
					Thread.sleep(1000);
					ReadSafety();
					if(Safety == 'Y'){
						Safety = 'r';
						WriteSafety();
						break;
					}
				}
			}
		}
		catch(InterruptedException e){}
	}
	private void Limit()
	{
		try{
			ReadMotor();
			ReadLimit();
			switch(Motor)
			{
			case 's':
				if(Limit.equals("yynnyynn")){
					L_x = 60;
					R_x = 120;
					y = 240;
					repaint();
					Thread.sleep(1000);
				}
				else if(Limit.equals("yynnnnyy")){
					L_x = 0;
					R_x = 180;
					y = 240;
					repaint();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnyyyynn")){
					L_x = 60;
					R_x = 120;
					y = 0;
					repaint();
					Thread.sleep(1000);
				}
				else if(Limit.equals("yynnnnyy")){
					L_x = 0;
					R_x = 180;
					y = 0;
					repaint();
					Thread.sleep(1000);
				}
				break;
			case 't':
				if(Limit.equals("yynnnnyy")){
					Limit = "yynnnnyn";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnyynnyy")){
					Limit = "nnyynnyn";
					WriteLimit();
					Thread.sleep(1000);
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'c':
				if(Limit.equals("yynnnnyn")){
					Limit = "yynnnnnn";
					WriteLimit();
					for(int j = 0; j < 15; j++){
						L_x = j;
						R_x = 180 - j;
						y = 240;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("yynnnynn")){
					Limit = "yynnyynn";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = j;
						R_x = 180 - j;
						y = 240;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("nnyynnyn")){
					Limit = "nnyynnnn";
					WriteLimit();
					for(int j = 0; j < 15; j++){
						L_x = j;
						R_x = 180 - j;
						y = 0;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("nnyynynn")){
					Limit = "nnyyyynn";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = j;
						R_x = 180 - j;
						y = 0;
						repaint();
						Thread.sleep(66);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'C':
				if(Limit.equals("yynnnnnn")){
					Limit = "yynnnynn";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = j;
						R_x = 180 - j;
						y = 240;
						repaint();
						Thread.sleep(33);
					}
				}
				else if(Limit.equals("nnyynnnn")){
					Limit = "nnyynynn";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = j;
						R_x = 180 - j;
						y = 0;
						repaint();
						Thread.sleep(33);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'j':
				if(Limit.equals("yynnyynn")){
					Limit = "nynnyynn";
					WriteLimit();
					Thread.sleep(1000);
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'u':
				if(Limit.equals("nynnyynn")){
					Limit = "nnnnyynn";
					WriteLimit();
					for(int i = 240; i > 180; i--){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(16);
					}
				}
				else if(Limit.equals("nnynyynn")){
					Limit = "nnyyyynn";
					WriteLimit();
					for(int i = 60; i > 0; i--){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(16);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'U':
				if(Limit.equals("nnnnyynn")){
					Limit = "nnynyynn";
					WriteLimit();
					for(int i = 180; i > 60; i--){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(8);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'k':
				if(Limit.equals("nnyyyynn")){
					Limit = "nnynyynn";
					WriteLimit();
					Thread.sleep(1000);
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'd':
				if(Limit.equals("nnynyynn")){
					Limit = "nnnnyynn";
					WriteLimit();
					for(int i = 0; i < 60; i++){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(16);
					}
				}
				else if(Limit.equals("nynnyynn")){
					Limit = "yynnyynn";
					WriteLimit();
					for(int i = 180; i < 240; i++){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(16);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'D':
				if(Limit.equals("nnnnyynn")){
					Limit = "nynnyynn";
					WriteLimit();
					for(int i = 60; i < 180; i++){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(8);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'h':
				if(Limit.equals("nnyyyynn")){
					Limit = "nnyynynn";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("yynnyynn")){
					Limit = "yynnnynn";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnyynynn")){
					Limit = "nnyynnyn";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 0;
						repaint();
						Thread.sleep(33);
					}
				}
				else if(Limit.equals("nnyynnyn")){
					Limit = "nnyynnyy";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("yynnnynn")){
					Limit = "yynnnnyn";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 240;
						repaint();
						Thread.sleep(33);
					}
				}
				else if(Limit.equals("yynnnnyn")){
					Limit = "yynnnnyy";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnyynnnn")){
					Limit = "nnyynnyy";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 0;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("yynnnnnn")){
					Limit = "yynnnnyy";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 240;
						repaint();
						Thread.sleep(66);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'o':
				if(Limit.equals("nnyynynn")){
					Limit = "nnyynnnn";
					WriteLimit();
					for(int j = 0; j < 15; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 0;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("nnyynnyn")){
					Limit = "nnyynnyy";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 0;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("yynnnynn")){
					Limit = "yynnnnnn";
					WriteLimit();
					for(int j = 0; j < 15; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 240;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("yynnnnyn")){
					Limit = "yynnnnyy";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 240;
						repaint();
						Thread.sleep(66);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'O':
				if(Limit.equals("nnyynnnn")){
					Limit = "nnyynnyn";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 0;
						repaint();
						Thread.sleep(33);
					}
				}
				else if(Limit.equals("yynnnnnn")){
					Limit = "yynnnnyn";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 240;
						repaint();
						Thread.sleep(33);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			default:
				Thread.sleep(1000);
				break;
			}
		}
		catch(InterruptedException e){}
	}
	public void run()
	{
		while(true)
		{
			Safety();
			Limit();
		}
	}
	public void paintComponent(Graphics g)
	{
		g.setColor(Color.green);
		g.fillRect(0, 0, width, height);
		g.setColor(Color.lightGray);
		g.fillRect(L_x + 60, y, R_x - L_x - 60, 120);
		g.setColor(Color.yellow);
		g.fillRect(L_x, y, 60, 120);
		g.fillRect(R_x, y, 60, 120);
		g.setColor(Color.black);
		g.drawRect(L_x + 60, y, R_x - L_x - 60, 120);
		g.drawRect(L_x, y, 60, 120);
		g.drawRect(R_x, y, 60, 120);
	}
	public void setmySize(int w, int h)
	{
		if(width > 0 && width < 1000)
		{
			width = w;
		}
		if(height > 0 && height < 500)
		{
			height = h;
		}
	}
	public void debug(int i)
	{
		System.out.println("Debug " + i);
	}
	private void ReadSafety()
	{
		Safety = EV_JFile.Read(Safety, "Safety.txt");
	}
	private void WriteSafety()
	{
		EV_JFile.Write(Safety, "Safety.txt");
	}
	private void ReadMotor()
	{
		Motor = EV_JFile.Read(Motor, "Motor.txt");
	}
	private void ReadLimit()
	{
		Limit = EV_JFile.Read(Limit, "Limit.txt");
	}
	private void WriteLimit()
	{
		EV_JFile.Write(Limit, "Limit.txt");
	}
	private void ReadPermitTurnOpen()
	{
		PermitTurnOpen = EV_JFile.Read(PermitTurnOpen, "PermitTurnOpen.txt");
	}
	private void WriteTurnOpen()
	{
		EV_JFile.Write(TurnOpen, "TurnOpen.txt");
	}
	public void Wait_ms(int ms)
	{
		try{
			Thread.sleep(ms);
		}
		catch(InterruptedException e){}
	}
}
