/*
	R@EV
	
	vO@F@CTL.c
	
	dlF@
	@Gx[^̃\tgEV̐vOB
	@C++ō쐬EV_Controller.cpp̑pCō쐬B
*/

/*
 * R EV
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */

#include "EV3.h"
#include "CTL.h"

/*
 * C[`
 * 
 * 쐬 2010/01/13
 * 쐬 {
 */
void	main(int argc , char *argv[])
{
	/* argp[vJE^ */
	int cnt_arg;

	/* Gx[^[݈̌ʒuIuWFNg̐錾 */
	struct Position P;

	/* ㏸IuWFNg̐錾 */
	struct UpMotor UPMT;
	/* ~IuWFNg̐錾 */
	struct DownMotor DNMT;

	/* Gx[^[̈ʒuzO */
	struct WaitPositionChangeLog	WPCL;

	/* Gx[^[݈̌ʒuIuWFNg̐錾 */
	struct Door DR;

	/* JIuWFNg̐錾 */
	struct OpenMotor OPMT;
	/* IuWFNg̐錾 */
	struct CloseMotor CLMT;

	/* Gx[^[̈ʒuzO */
	struct WaitDoorChangeLog WDCL;

	/* oߎԃe| */
	struct CTime T;
	struct CTime OpenTO;

	/*  */
	char Command;
	char *p_Command;

	/* t@CXg[ */
	struct CFile CF;
	struct CFile TOF;
	struct CFile LF;

	/* s̔]J */
	int TurnOpen;
	int *p_TurnOpen;
	
	/*  */
	Position(&P);
	UpMotor(&UPMT);
	DownMotor(&DNMT);
	WaitPositionChangeLog(&WPCL);
	Door(&DR);
	OpenMotor(&OPMT);
	CloseMotor(&CLMT);
	WaitDoorChangeLog(&WDCL);
	CTime(&T);
	CTime(&OpenTO);
	CFile(&CF);
	CFile(&TOF);
	CFile(&LF);
	
	/* ߏ */
	p_Command = &Command;
	
	/* s̔]J */
	p_TurnOpen = &TurnOpen;
	*p_TurnOpen = OFF;
	
	/* [^[~ */
	Motor_Write(&LF, 's');

	/* Gx[^[̈ʒuzO */
	/* l */
	OnInitWaitPositionChangeLog(&WPCL, P);

	/* Gx[^[̈ʒuzO */
	/* l */
	OnInitWaitDoorChangeLog(&WDCL, DR);

	/* t@C */
	if(PermitCommand_Write(&CF, 'N') == NG) return;
	if(Command_Write(&CF, 'N') == NG) return;
	if(PermitTurnOpen_Write(&TOF, 'N') == NG) return;
	if(TurnOpen_Write(&TOF, 'N') == NG) return;

	do{
		for(cnt_arg = 1; cnt_arg < argc; cnt_arg++){
			printf("%s", argv[cnt_arg]);
			if(cnt_arg == argc - 1) printf("\n");
			else printf(" ");
		}

		/* ߓ͋ */
		if(PermitCommand_Write(&CF, 'c') == NG) return;

		/* ͎w
		printf("㏸́uuvA~́udvAJ́uovA́ucvAÍuqv\n");
		printf("KẮuyvAKẮuYvAK́uhvAK́uHv\n");
		printf("R}hH ");
		
		do{
			//	ߓ
			Command = getchar();
			printf("%c\n",Command);
		}while(Command == '\n');
		//	ߓ
		Command = getche(); */
		
		while(1){
			/* ߓ */
			switch(Command_Read(&CF, p_Command)){
			case NG:
				return;
				break;
			case ONE_MORE_TIME:
				if((GetPermit(&OpenTO) == ON)
					&& (GetCurrentTime(&OpenTO) > OPENTIMEOUT)){
					printf("J^CAEg\n");
					Command = 'c';
					break;
				}
				continue;
				break;
			default:
				break;
			}

			if((Command == 'u') || (Command == 'Y')
				|| (Command == 'd') || (Command == 'y')
				|| (Command == 'o') || (Command == 'c')
				|| (Command == 'H') || (Command == 'h')){
				/* ߓ͋I */
				if(PermitCommand_Write(&CF, 'N') == NG) return;

        /* ߐMێ */
				WaitSecond(&T, 1);

				/* ߓ͎I */
				if(Command_Write(&CF, 'N') == NG) return;

				if(((*P.p_UnderStop == ON)
					&& ((Command == 'u') || (Command == 'd')
					|| (Command == 'o') || (Command == 'c')
					|| (Command == 'y') || (Command == 'h')))
					|| ((*P.p_UpperStop == ON)
					&& ((Command == 'u') || (Command == 'd')
					|| (Command == 'o') || (Command == 'c')
					|| (Command == 'Y') || (Command == 'H')))){
					SetPermit(&OpenTO, OFF);
				}

				break;
			}
			else if(Command == 'q'){
				/* ߓ͋I */
				if(PermitCommand_Write(&CF, 'N') == NG) return;

				break;
			}
			else{
				/* ̑̓ǂݍݒl */
				/* Sleep */
				Wait_ms(200);
			}
		}

		switch(Command){
			/* KĖ߂Ȃ */
			case	'Y':
				if((*P.p_UnderStop == ON) && (*DR.p_OpennerStop == ON)){
					printf("̊KĂ͗L܂\n");
					break;
				}
			/* ㏸߂Ȃ */
			case	'u':
				if(*P.p_UpperStop == ON){
					/* J */
					Open(DR,OPMT,WDCL,&OpenTO);
				}
				else{
					/*  */
					Close(P,DR,CLMT,p_TurnOpen,OPMT,WDCL,&OpenTO);

					/*  */
					if(*p_TurnOpen == OFF){
						/* ㏸ */
						Up(P,UPMT,WPCL);

						/* J */
						Open(DR,OPMT,WDCL,&OpenTO);
					}

					/* ɖ߂ */
					*p_TurnOpen = OFF;
				}

				break;
			/* KĖ߂Ȃ */
			case	'y':
				if((*P.p_UpperStop == ON) && (*DR.p_OpennerStop == ON)){
					printf("̊KĂ͗L܂\n");
					break;
				}
			/* ~߂Ȃ */
			case	'd':
				if(*P.p_UnderStop == ON){
					/* J */
					Open(DR,OPMT,WDCL,&OpenTO);
				}
				else{
					/*  */
					Close(P,DR,CLMT,p_TurnOpen,OPMT,WDCL,&OpenTO);

					/*  */
					if(*p_TurnOpen == OFF){
						/* ~ */
						Down(P,DNMT,WPCL);

						/* J */
						Open(DR,OPMT,WDCL,&OpenTO);
					}

					/* ɖ߂ */
					*p_TurnOpen = OFF;
				}

				break;
			/* J߂Ȃ */
			case	'o':
				/* J */
				Open(DR,OPMT,WDCL,&OpenTO);

				break;
			/* ߂Ȃ */
			case	'c':
				/*  */
				Close(P,DR,CLMT,p_TurnOpen,OPMT,WDCL,&OpenTO);

				/* ɖ߂ */
				*p_TurnOpen = OFF;

				break;
			/* ߂Ȃ */
			case	'H':
				if(*P.p_UpperStop == ON){
					/*  */
					Close(P,DR,CLMT,p_TurnOpen,OPMT,WDCL,&OpenTO);

					/* ɖ߂ */
					*p_TurnOpen = OFF;
				}
				else{
					printf("̊KĂ͗L܂\n");
				}

				break;
			/* ߂Ȃ */
			case	'h':
				if(*P.p_UnderStop == ON){
					/*  */
					Close(P,DR,CLMT,p_TurnOpen,OPMT,WDCL,&OpenTO);

					/* ɖ߂ */
					*p_TurnOpen = OFF;
				}
				else{
					printf("̊KĂ͗L܂\n");
				}

				break;
			default:
				break;
		}
	/* I߂Ȃ */
	}while(Command != 'q');
	
	return;
}
