/* UPDN.c */

#include "EV3.h"
#include "UPDN.h"

/*=====================================================================
  ㏸~\֐
  =====================================================================*/
/*
 * Position
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void Position(struct Position *this)
{
	/* l */
	this->m_UNSL = OFF;
	this->m_UNST = OFF;
	this->m_UPSL = OFF;
	this->m_UPST = OFF;
	this->p_UnderSlow = &this->m_UNSL;
	this->p_UnderStop = &this->m_UNST;
	this->p_UpperSlow = &this->m_UPSL;
	this->p_UpperStop = &this->m_UPST;
	/* Sleepp */
	this->fstop = OFF;
	this->p_fstop = &this->fstop;
	this->fmove = OFF;
	this->p_fmove = &this->fmove;
	
	/* ߂ */
	return;
}

/*
 * UpMotor
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void UpMotor(struct UpMotor *this)
{
	CFile(&this->LF);
	
	/* ߂ */
	return;
}

/*
 * OnUpMotor
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
/* ㏸ */
void OnUpMotor(struct UpMotor *this, struct Position P)
{
	if(*P.p_UpperStop == ON){
		/* Sleepp */
		if(*P.p_fstop == OFF){
			*P.p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 's');
			printf("STOP܂\n");
		}
	}
	else if(*P.p_UpperSlow == ON){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'u');
			printf("UP܂\n");
		}
	}
	else if(*P.p_UnderSlow == OFF){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'U');
			printf("UP܂\n");
		}
	}
	else if(*P.p_UnderStop == OFF){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'u');
			printf("UP܂\n");
		}
	}
	else if(*P.p_UnderStop == ON){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'j');
			printf("㏸܂\n");
		}
	}
	
	/* ߂ */
	return;
}

/*
 * DownMotor
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void DownMotor(struct DownMotor *this)
{
	CFile(&this->LF);
	
	/* ߂ */
	return;
}

/*
 * OnDownMotor
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
/* ~ */
void OnDownMotor(struct DownMotor *this, struct Position P)
{
	if(*P.p_UnderStop == ON){
		/* Sleepp */
		if(*P.p_fstop == OFF){
			*P.p_fstop = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 's');
			printf("STOP܂\n");
		}
	}
	else if(*P.p_UnderSlow == ON){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'd');
			printf("DOWN܂\n");
		}
	}
	else if(*P.p_UpperSlow == OFF){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'D');
			printf("DOWN܂\n");
		}
	}
	else if(*P.p_UpperStop == OFF){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'd');
			printf("DOWN܂\n");
		}
	}
	else if(*P.p_UpperStop == ON){
		/* Sleepp */
		*P.p_fstop = OFF;
		if(*P.p_fmove == OFF){
			*P.p_fmove = ON;
			/* ݎs̖߂Oɕ */
			Motor_Write(&this->LF, 'k');
			printf("~܂\n");
		}
	}
	
	/* ߂ */
	return;
}

/*
 * WaitPositionChangeLog
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
/* Gx[^[̈ʒuzO */
void WaitPositionChangeLog(struct WaitPositionChangeLog *this)
{
	this->p_strLimit = &this->strLimit[0];
	
	/* ߂ */
	return;
}

/*
 * OnInitWaitPositionChangeLog
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
/* Gx[^[̈ʒuzO */
void OnInitWaitPositionChangeLog(struct WaitPositionChangeLog *this, struct Position P)
{
	/* ZTl */
	/* ~bgXCb`̓ǂݍ */
	this->p_strLimit = &this->strLimit[0];
	Limit_Read(&this->LF, this->p_strLimit);
	this->tmp = ((this->strLimit[0] == 'y') ? ON : OFF);
	Checkfmove(P.p_UnderStop, P.p_fmove, this->tmp);
	this->tmp = ((this->strLimit[1] == 'y') ? ON : OFF);
	Checkfmove(P.p_UnderSlow, P.p_fmove, this->tmp);
	this->tmp = ((this->strLimit[2] == 'y') ? ON : OFF);
	Checkfmove(P.p_UpperSlow, P.p_fmove, this->tmp);
	this->tmp = ((this->strLimit[3] == 'y') ? ON : OFF);
	Checkfmove(P.p_UpperStop, P.p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * OnWaitUpPositionChangeLog
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
/* Gx[^[̈ʒuzO */
void OnWaitUpPositionChangeLog(struct WaitPositionChangeLog *this, struct Position P)
{
	/* ~bgXCb`̓ǂݍ */
	this->p_strLimit = &this->strLimit[0];
	Limit_Read(&this->LF, this->p_strLimit);
	this->tmp = (this->strLimit[0] == 'y') ? ON : OFF;
	Checkfmove(P.p_UnderStop, P.p_fmove, this->tmp);
	this->tmp = (this->strLimit[1] == 'y') ? ON : OFF;
	Checkfmove(P.p_UnderSlow, P.p_fmove, this->tmp);
	this->tmp = (this->strLimit[2] == 'y') ? ON : OFF;
	Checkfmove(P.p_UpperSlow, P.p_fmove, this->tmp);
	this->tmp = (this->strLimit[3] == 'y') ? ON : OFF;
	Checkfmove(P.p_UpperStop, P.p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * OnWaitDownPositionChangeLog
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
/* Gx[^[̈ʒuzO */
void OnWaitDownPositionChangeLog(struct WaitPositionChangeLog *this, struct Position P)
{
	/* ~bgXCb`̓ǂݍ */
	this->p_strLimit = &this->strLimit[0];
	Limit_Read(&this->LF, this->p_strLimit);
	this->tmp = (this->strLimit[0] == 'y') ? ON : OFF;
	Checkfmove(P.p_UnderStop, P.p_fmove, this->tmp);
	this->tmp = (this->strLimit[1] == 'y') ? ON : OFF;
	Checkfmove(P.p_UnderSlow, P.p_fmove, this->tmp);
	this->tmp = (this->strLimit[2] == 'y') ? ON : OFF;
	Checkfmove(P.p_UpperSlow, P.p_fmove, this->tmp);
	this->tmp = (this->strLimit[3] == 'y') ? ON : OFF;
	Checkfmove(P.p_UpperStop, P.p_fmove, this->tmp);
	
	/* ߂ */
	return;
}

/*
 * Up
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
/* ㏸ */
void Up(struct Position P, struct UpMotor UPMT, struct WaitPositionChangeLog WPCL)
{
	/* ㏸mFp */
	struct CFile LF;
	CFile(&LF);

	/* ܂ */
	while((*P.p_UpperStop == OFF)
		|| (Motor_Read(&LF) != 's')){
		/* ㏸ */
		OnUpMotor(&UPMT, P);

		/* oߎ */
		/* Sleep */
		Wait_ms(500);
		
		/* Gx[^[̈ʒuzO */
		OnWaitUpPositionChangeLog(&WPCL, P);
	}
	/* ݏK */
	printf("̊Kł\n");
	
	/* ߂ */
	return;
}

/*
 * Down
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
/* ~ */
void Down(struct Position P, struct DownMotor DNMT, struct WaitPositionChangeLog WPCL)
{
	/* ~mFp */
	struct CFile LF;
	CFile(&LF);

	/* ܂ */
	while((*P.p_UnderStop == OFF)
		|| (Motor_Read(&LF) != 's')){
		/* ~ */
		OnDownMotor(&DNMT, P);

		/* oߎ */
		/* Sleep */
		Wait_ms(500);
		
		/* Gx[^[̈ʒuzO */
		OnWaitDownPositionChangeLog(&WPCL, P);
	}
	/* ݉K */
	printf("̊Kł\n");
	
	/* ߂ */
	return;
}
