/*
	R@EV4
	
	vO@F@CTL.c
	
	dlF@
	@Gx[^̃\tgEV̐vOB
	@C++ō쐬EV_Controller.cpp̑pCō쐬B
*/

/*
 * R EV4
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */

#include "EV4.h"
#include "CTL.h"

/*=====================================================================
  ̓IuWFNg錾
  =====================================================================*/
struct CInput in;

/*=====================================================================
  ֐
  =====================================================================*/
void CController(struct CController *this, struct Handle_Thread *th)
{	
	/*  */
	this->p_P = &this->P;
	Position(this->p_P);
	UpMotor(&this->UPMT);
	DownMotor(&this->DNMT);
	WaitPositionChangeLog(&this->WPCL);
	this->p_DR = &this->DR;
	Door(this->p_DR);
	OpenMotor(&this->OPMT);
	CloseMotor(&this->CLMT);
	WaitDoorChangeLog(&this->WDCL);
	CTime(&this->T, th);
	CFile(&this->CF);
	CFile(&this->LF);
	
	/* S */
	this->p_Safety = &this->Safety;
	
	/* ߏ */
	this->p_Command = &this->Command;
	
	/* [^[~ */
	Motor_Write(&this->LF, 's');

	/* Gx[^[̈ʒuzO */
	/* l */
	OnInitWaitPositionChangeLog(&this->WPCL, this->p_P);

	/* Gx[^[̈ʒuzO */
	/* l */
	OnInitWaitDoorChangeLog(&this->WDCL, this->p_DR);

	/* t@C */
	if(PermitCommand_Write(&this->CF, 'c') == NG) return;
	
	CInput(&in);	
}

/*
 * 吧֐
 */
void OnController(struct CController *this, struct Handle_Thread *th)
{
	/* S */
	if(Read(&this->CF, "Safety.txt", this->p_Safety) == NG) return;
	
#ifndef USE_H8_3052F
#ifndef USE_GCC
	if(kbhit())
	{
		/* ߓ͋ */
		if(PermitCommand_Write(&this->CF, 'c') == NG) return;
		OnInput(&in);
	}
#endif
#endif
		
	/* ߓ */
	if(Command_Read(&this->CF, this->p_Command) == NG) return;
	
	if(this->Command != 'q')
	{			
		/* ߓ */
		switch(this->Command){
		case NG:
			return;
			break;
		case ONE_MORE_TIME:
			break;
		default:
			break;
		}

		if(((this->Safety == 'r') || (this->Safety == 'Y'))
			&& ((this->Command == 'u') || (this->Command == 'Y')
			|| (this->Command == 'd') || (this->Command == 'y')
			|| (this->Command == 'o') || (this->Command == 'c')
			|| (this->Command == 'H') || (this->Command == 'h')));
		else{
			/* ̑̓ǂݍݒl */
			PrintF(InputCommand, "Hello EV");
		
			DispInput();
			OnInput(&in);
		}
		
		switch(this->Command){
			/* KĖ߂Ȃ */
			case	'Y':
				if((*this->p_P->p_UnderStop == ON) && (*this->p_DR->p_OpennerStop == ON)){
					PrintF(Panel, "\nA Basket isn't 2nd Floor");
					Command_Write(&this->CF, 'N');
					break;
				}
			/* ㏸߂Ȃ */
			case	'u':
				if(*this->p_P->p_UpperStop == ON){
					/* J */
					if(*this->p_DR->p_OpennerStop == ON){
						Command_Write(&this->CF, 'N');
					}
					else{
						/* J */
						Open(this->p_DR,this->OPMT,this->WDCL, th);
					}
				}
				else if(*this->p_DR->p_CloserStop == ON){
					/*  */
					/* ㏸ */
					Up(this->p_P,this->UPMT,this->WPCL, th);
				}
				else if(*this->p_DR->p_CloserStop == OFF){
					/*  */
					Close(this->p_DR,this->CLMT,this->WDCL, th);
                                }
				break;
			/* KĖ߂Ȃ */
			case	'y':
				if((*this->p_P->p_UpperStop == ON) && (*this->p_DR->p_OpennerStop == ON)){
					PrintF(Panel, "\nA Basket isn't 1st Floor");
					Command_Write(&this->CF, 'N');
					break;
				}
			/* ~߂Ȃ */
			case	'd':
				if(*this->p_P->p_UnderStop == ON){
					/* J */
					if(*this->p_DR->p_OpennerStop == ON){
						Command_Write(&this->CF, 'N');
					}
					else{
						/* J */
						Open(this->p_DR,this->OPMT,this->WDCL, th);
					}
				}
				else if(*this->p_DR->p_CloserStop == ON){
					/*  */
					/* ㏸ */
					Down(this->p_P,this->DNMT,this->WPCL, th);
				}
				else if(*this->p_DR->p_CloserStop == OFF){
					/*  */
					Close(this->p_DR,this->CLMT,this->WDCL, th);
                                }
				break;
			/* J߂Ȃ */
			case	'o':
				/* J */
				if(*this->p_DR->p_OpennerStop == ON){
					Command_Write(&this->CF, 'N');
				}
				else{
					/* J */
					Open(this->p_DR,this->OPMT,this->WDCL, th);
				}
				break;
			/* ߂Ȃ */
			case	'c':
				/*  */
				if(*this->p_DR->p_CloserStop == ON){
					Command_Write(&this->CF, 'N');
				}
				else{
					/*  */
					Close(this->p_DR,this->CLMT,this->WDCL, th);
				}
				break;
			/* ߂Ȃ */
			case	'H':
				if(*this->p_P->p_UpperStop == ON){
					/*  */
					if(*this->p_DR->p_CloserStop == ON){
						Command_Write(&this->CF, 'N');
					}
					else{
						/*  */
						Close(this->p_DR,this->CLMT,this->WDCL, th);
					}
				}
				else{
					PrintF(Panel, "\nA Basket isn't 2nd Floor");
					Command_Write(&this->CF, 'N');
				}
				
				break;
			/* ߂Ȃ */
			case	'h':
				if(*this->p_P->p_UnderStop == ON){
					/*  */
					if(*this->p_DR->p_CloserStop == ON){
						Command_Write(&this->CF, 'N');
					}
					else{
						/*  */
						Close(this->p_DR,this->CLMT,this->WDCL, th);
					}
				}
				else{
					PrintF(Panel, "\nA Basket isn't 1st Floor");
					Command_Write(&this->CF, 'N');
				}
				
				break;
			default:
				break;
		}
	}
	/* I߂Ȃ */
	else
	{
		/* ߓ͋I */
		if(PermitCommand_Write(&this->CF, 'N') == NG) return;
		
		/* ߏI */
		if(Command_Write(&this->CF, 'N') == NG) return;
		
#ifndef USE_H8_3052F
		exit(1);
#endif
	}
	
	return;
}
