/* FILE.c */

#include "EV4.h"
#include "FILE.h"

/*=====================================================================
  t@CsgpIuWFNg錾
  =====================================================================*/
#ifdef NOTUSE_FILES
struct Handle_Status status;
#endif

/*=====================================================================
  t@C\֐
  =====================================================================*/
#ifdef NOTUSE_FILES
void Status(struct Status *this)
{
	this->p_status = &status;
	status.safety = 'r';
	status.p_limit = &status.limit[0];
	strcpy(status.p_limit, "yynnyynn\0");
	status.motor = 's';
	status.command = 'N';
	status.permitcommand = 'N';
}
#endif

/*
 * CFile
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void CFile(struct CFile *this)
{
	/* l */
	this->fp = NULL;
	
	/* ߂ */
	return;
}

#ifdef NOTUSE_FILES
int Write(struct CFile *this, char *filename, char ch)
{
	switch(filename[0])
	{
	case 'S':
		status.safety = ch;
		break;
	case 'M':
		status.motor = ch;
		break;
	case 'C':
		status.command = ch;
		break;
	case 'P':
		status.permitcommand = ch;
		break;
	default:
		break;
	}
	return OK;
}
#else
/*
 * Write
 */
int Write(struct CFile *this, char *filename, char ch)
{
	if((this->fp = fopen(filename, "w")) == NULL){
		return	NG;
	}
	else if(fputc(ch, this->fp) == ch){
		fclose(this->fp);
		return	OK;
	}
	else{
		fclose(this->fp);
		return	NG;
	}
}
#endif

#ifdef NOTUSE_FILES
int WriteString(struct CFile *this, char *filename, char *str)
{
	switch(filename[0])
	{
	case 'L':
		status.p_limit = &status.limit[0];
		strcpy(status.p_limit, str);
		break;
	default:
		break;
	}
	return OK;
}
#else
/* 񏑂 */
int WriteString(struct CFile *this, char *filename, char *str)
{
	if((this->fp = fopen(filename, "w")) == NULL){
		return	NG;
	}
	/* \n͒ǋLȂ */
	else if(fputs(str, this->fp) >= 0){
		fclose(this->fp);
		/* ݐ */
		return	OK;
	}
	else{
		fclose(this->fp);
		/* ݎs */
		return	NG;
	}
}
#endif

#ifdef NOTUSE_FILES
int Read(struct CFile *this, char *filename, char *p_ch)
{
	switch(filename[0])
	{
	case 'S':
		*p_ch = status.safety;
		break;
	case 'M':
		*p_ch = status.motor;
		break;
	case 'C':
		*p_ch = status.command;
		break;
	case 'P':
		*p_ch = status.permitcommand;
		break;
	default:
		break;
	}
	return OK;
}
#else
/*
 * Read
 */
int Read(struct CFile *this, char *filename, char *p_ch)
{
	if((this->fp = fopen(filename, "r")) == NULL){
		return NG;
	}
	else if((*p_ch = fgetc(this->fp)) == EOF){
		fclose(this->fp);
		return ONE_MORE_TIME;
	}
	else if(*p_ch == '\n'){
		fclose(this->fp);
		return ONE_MORE_TIME;
	}
	else if(*p_ch == 'N'){
		fclose(this->fp);
		return ONE_MORE_TIME;
	}
	else{
		fclose(this->fp);
		return OK;
	}
}
#endif

#ifdef NOTUSE_FILES
int ReadString(struct CFile *this, char *filename, char *str, int strlength)
{
	switch(filename[0])
	{
	case 'L':
		status.p_limit = &status.limit[0];
		strcpy(str, status.p_limit);
		break;
	default:
		break;
	}
	return OK;
}
#else
/*
 * ReadString
 */
int ReadString(struct CFile *this, char *filename, char *str, int strlength)
{
	if((this->fp = fopen(filename, "r")) == NULL){
		return NG;
	}
	else if(fgets(str, strlength, this->fp) == NULL){
		fclose(this->fp);
		return ONE_MORE_TIME;
	}
	else if(str[0] == '\n'){
		fclose(this->fp);
		return ONE_MORE_TIME;
	}
	else if(str[0] == 'N'){
		fclose(this->fp);
		return ONE_MORE_TIME;
	}
	else{
		fclose(this->fp);
		return OK;
	}
}
#endif

/*
 * PermitCommand_Write
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int PermitCommand_Write(struct CFile *this, char PermitCommand)
{
	switch(Write(this, "PermitCommand.txt\0", PermitCommand)){
	case NG:
		PrintF(Panel, "\nWriting Error");
		return	NG;
		break;
	case OK:
		return	OK;
		break;
	default:
		return	NG;
		break;
	}
}

/*
 * Command_Read
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int Command_Read(struct CFile *this, char *p_Command)
{
	switch(Read(this, "Command.txt\0", p_Command)){
	case NG:
		PrintF(Panel, "\nReading Error");
		return NG;
		break;
	case ONE_MORE_TIME:
		return ONE_MORE_TIME;
		break;
	default:
		return OK;
		break;
	}
}

/*
 * Command_Write
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int Command_Write(struct CFile *this, char Command)
{
	switch(Write(this, "Command.txt\0", Command)){
	case NG:
		PrintF(Panel, "\nWriting Error");
		return NG;
		break;
	case OK:
		return OK;
		break;
	default:
		return	NG;
		break;
	}
}

/*
 * PermitTurnOpen_Write
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int PermitTurnOpen_Write(struct CFile *this, char PermitTurnOpen)
{
	switch(Write(this, "PermitTurnOpen.txt\0", PermitTurnOpen)){
	case NG:
		PrintF(Panel, "\nWriting Error");
		return	NG;
		break;
	case OK:
		return	OK;
		break;
	default:
		return	NG;
		break;
	}
}

/*
 * TurnOpen_Read
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int TurnOpen_Read(struct CFile *this, char *p_chTurnOpen)
{
	switch(Read(this, "TurnOpen.txt\0", p_chTurnOpen)){
	case NG:
		PrintF(Panel, "\nReading Error");
		return NG;
		break;
	case ONE_MORE_TIME:
		return ONE_MORE_TIME;
		break;
	default:
		return OK;
		break;
	}
}

/*
 * TurnOpen_Write
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
int TurnOpen_Write(struct CFile *this, char TurnOpen)
{
	switch(Write(this, "TurnOpen.txt\0", TurnOpen)){
	case NG:
		PrintF(Panel, "\nWriting Error");
		return NG;
		break;
	case OK:
		return OK;
		break;
	default:
		return	NG;
		break;
	}
}

/*
 * Motor_Write
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void Motor_Write(struct CFile *this, char Motor)
{
	switch(Write(this, "Motor.txt\0", Motor)){
	case NG:
		PrintF(Panel, "\nWriting Error");
		break;
	case OK:
		return;
		break;
	default:
		break;
	}
	
	/* ߂ */
	return;
}

/*
 * Motor_Read
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
char Motor_Read(struct CFile *this)
{
	char ch;
	char *p_ch;
	ch = '\0';
	p_ch = &ch;

	switch(Read(this, "Motor.txt\0", p_ch)){
	case NG:
		break;
	case ONE_MORE_TIME:
		return '\0';
		break;
	case OK:
		return ch;
		break;
	default:
		break;
	}
	return '\0';
}

/*
 * Limit_Read
 * 
 * 쐬 2010/01/12
 * 쐬 {
 */
void Limit_Read(struct CFile *this, char *str)
{
	switch(ReadString(this, "Limit.txt\0", str, 9)){
	case NG:
		PrintF(Panel, "\nReading Error");
		break;
	case ONE_MORE_TIME:
		return;
		break;
	default:
		return;
		break;
	}
	
	/* ߂ */
	return;
}
