/* OPCL.h */

#ifndef PRINTF_h
#define PRINTF_h
#include "PRINTF.h"
#endif

#ifndef TIME_h
#define	TIME_h
#include "TIME.h"
#endif

#ifndef FILE_h
#define	FILE_h
#include "FILE.h"
#endif

#ifndef UPDN_h
#define	UPDN_h
#include "UPDN.h"
#endif

/*=====================================================================
  J\\
  =====================================================================*/
struct Door
{
	int m_CLSL;
	int m_CLST;
	int m_OPSL;
	int m_OPST;
	/* ʒu */
	int *p_CloserSlow;
	/* ~ʒu */
	int *p_CloserStop;
	/* Jʒu */
	int *p_OpennerSlow;
	/* J~ʒu */
	int *p_OpennerStop;
	/* Sleepp */
	int fstop;
	int *p_fstop;
	int fmove;
	int *p_fmove;
};

/* J */
struct OpenMotor
{
	struct CFile LF;
};

/*  */
struct CloseMotor
{
	struct CFile	LF;
};

/* Gx[^[̈ʒuzO */
struct WaitDoorChangeLog
{
	struct CFile TOF;
	char chTurnOpen;
	char *p_chTurnOpen;
	struct CFile LF;
	char strLimit[9];
	char *p_strLimit;
	/* Sleepp */
	int tmp;
};

/*=====================================================================
  J\vg^Cv錾
  =====================================================================*/
void Door(struct Door *this);
/* J */
void OpenMotor(struct OpenMotor *this);
void OnOpenMotor(struct OpenMotor *this, struct Door DR);
/*  */
void CloseMotor(struct CloseMotor *this);
void OnCloseMotor(struct CloseMotor *this, struct Door DR);
/* oߎ */
void WaitDoorChangeLog(struct WaitDoorChangeLog *this);
void OnInitWaitDoorChangeLog(struct WaitDoorChangeLog *this, struct Door *DR);
void OnWaitOpenDoorChangeLog(struct WaitDoorChangeLog *this, struct Door *DR);
void OnWaitCloseDoorChangeLog(struct WaitDoorChangeLog *this, struct Door *DR);
/* J */
void Open(struct Door *DR, struct OpenMotor OPMT, struct WaitDoorChangeLog WDCL, struct Handle_Thread *th);
/*  */
void Close(struct Door *DR, struct CloseMotor CLMT, struct WaitDoorChangeLog WDCL, struct Handle_Thread *th);
