//	UpDown.cpp

#include "EV_Controller.h"
#include "UpDown.h"

using namespace Time;
using namespace File;

namespace UpDown{
	Position::Position(){
		//	l
		m_UNSL = OFF;
		m_UNST = OFF;
		m_UPSL = OFF;
		m_UPST = OFF;
		p_UnderSlow = &m_UNSL;
		p_UnderStop = &m_UNST;
		p_UpperSlow = &m_UPSL;
		p_UpperStop = &m_UPST;
		//	Sleepp
		fstop = OFF;
		p_fstop = &fstop;
		fmove = OFF;
		p_fmove = &fmove;
	}

	//	㏸
	void	UpMotor::OnUpMotor(Position P){
		if(*P.p_UpperStop == ON){
			//	Sleepp
			if(*P.p_fstop == OFF){
				*P.p_fstop = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('s');
				printf("STOP܂\n");
			}
		}
		else if(*P.p_UpperSlow == ON){
			//	Sleepp
			*P.p_fstop = OFF;
			if(*P.p_fmove == OFF){
				*P.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('u');
				printf("UP܂\n");
			}
		}
		else if(*P.p_UnderSlow == OFF){
			//	Sleepp
			*P.p_fstop = OFF;
			if(*P.p_fmove == OFF){
				*P.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('U');
				printf("UP܂\n");
			}
		}
		else if(*P.p_UnderStop == OFF){
			//	Sleepp
			*P.p_fstop = OFF;
			if(*P.p_fmove == OFF){
				*P.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('u');
				printf("UP܂\n");
			}
		}
		else if(*P.p_UnderStop == ON){
			//	Sleepp
			*P.p_fstop = OFF;
			if(*P.p_fmove == OFF){
				*P.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('j');
				printf("㏸܂\n");
			}
		}

		return;
	}

	//	~
	void	DownMotor::OnDownMotor(Position P){
		if(*P.p_UnderStop == ON){
			//	Sleepp
			if(*P.p_fstop == OFF){
				*P.p_fstop = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('s');
				printf("STOP܂\n");
			}
		}
		else if(*P.p_UnderSlow == ON){
			//	Sleepp
			*P.p_fstop = OFF;
			if(*P.p_fmove == OFF){
				*P.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('d');
				printf("DOWN܂\n");
			}
		}
		else if(*P.p_UpperSlow == OFF){
			//	Sleepp
			*P.p_fstop = OFF;
			if(*P.p_fmove == OFF){
				*P.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('D');
				printf("DOWN܂\n");
			}
		}
		else if(*P.p_UpperStop == OFF){
			//	Sleepp
			*P.p_fstop = OFF;
			if(*P.p_fmove == OFF){
				*P.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('d');
				printf("DOWN܂\n");
			}
		}
		else if(*P.p_UpperStop == ON){
			//	Sleepp
			*P.p_fstop = OFF;
			if(*P.p_fmove == OFF){
				*P.p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('k');
				printf("~܂\n");
			}
		}

		return;
	}

	//	Gx[^[̈ʒuzO
	WaitPositionChangeLog::WaitPositionChangeLog(){
		p_strLimit = &strLimit[0];
	}

	//	Gx[^[̈ʒuzO
	void	WaitPositionChangeLog::OnInitWaitPositionChangeLog(Position P){
		//	ZTl
		//	~bgXCb`̓ǂݍ
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
		tmp = ((strLimit[0] == 'y') ? ON : OFF);
		Checkfmove(P.p_UnderStop, P.p_fmove, tmp);
		tmp = ((strLimit[1] == 'y') ? ON : OFF);
		Checkfmove(P.p_UnderSlow, P.p_fmove, tmp);
		tmp = ((strLimit[2] == 'y') ? ON : OFF);
		Checkfmove(P.p_UpperSlow, P.p_fmove, tmp);
		tmp = ((strLimit[3] == 'y') ? ON : OFF);
		Checkfmove(P.p_UpperStop, P.p_fmove, tmp);
	}

	//	Gx[^[̈ʒuzO
	void	WaitPositionChangeLog::OnWaitUpPositionChangeLog(Position P){
		//	~bgXCb`̓ǂݍ
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
		tmp = (strLimit[0] == 'y') ? ON : OFF;
		Checkfmove(P.p_UnderStop, P.p_fmove, tmp);
		tmp = (strLimit[1] == 'y') ? ON : OFF;
		Checkfmove(P.p_UnderSlow, P.p_fmove, tmp);
		tmp = (strLimit[2] == 'y') ? ON : OFF;
		Checkfmove(P.p_UpperSlow, P.p_fmove, tmp);
		tmp = (strLimit[3] == 'y') ? ON : OFF;
		Checkfmove(P.p_UpperStop, P.p_fmove, tmp);
	}

	//	Gx[^[̈ʒuzO
	void	WaitPositionChangeLog::OnWaitDownPositionChangeLog(Position P){
		//	~bgXCb`̓ǂݍ
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
		tmp = (strLimit[0] == 'y') ? ON : OFF;
		Checkfmove(P.p_UnderStop, P.p_fmove, tmp);
		tmp = (strLimit[1] == 'y') ? ON : OFF;
		Checkfmove(P.p_UnderSlow, P.p_fmove, tmp);
		tmp = (strLimit[2] == 'y') ? ON : OFF;
		Checkfmove(P.p_UpperSlow, P.p_fmove, tmp);
		tmp = (strLimit[3] == 'y') ? ON : OFF;
		Checkfmove(P.p_UpperStop, P.p_fmove, tmp);
	}

	//	㏸
	void	Up(Position P , UpMotor UPMT , WaitPositionChangeLog WPCL){
		//	㏸mFp
		CLimitFile		LF;

		//	܂
		while((*P.p_UpperStop == OFF)
			|| (LF.Motor_Read() != 's')){
			//	㏸
			UPMT.OnUpMotor(P);

			//	oߎ
			//	Sleep
			Wait_ms(500);
			
			//	Gx[^[̈ʒuzO
			WPCL.OnWaitUpPositionChangeLog(P);
		}
		//	݊K
		printf("̊Kł\n");

		//	߂
		return;
	}

	//	~
	void	Down(Position P , DownMotor DNMT , WaitPositionChangeLog WPCL){
		//	~mFp
		CLimitFile		LF;

		//	܂
		while((*P.p_UnderStop == OFF)
			|| (LF.Motor_Read() != 's')){
			//	~
			DNMT.OnDownMotor(P);

			//	oߎ
			//	Sleep
			Wait_ms(500);
			
			//	Gx[^[̈ʒuzO
			WPCL.OnWaitDownPositionChangeLog(P);
		}
		//	݊K
		printf("̊Kł\n");

		//	߂
		return;
	}
}
