import javax.swing.*;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class EV_Simulator_Display extends JPanel implements Runnable
{
	int L_x;
	int R_x;
	int y;
	int width;
	int height;
	char Safety;
	char Motor;
	String Limit;
	char PermitTurnOpen;
	char TurnOpen;
	
	public EV_Simulator_Display()
	{
		width = 100;
		height = 100;
		Safety();
		Limit();
		PermitTurnOpen = 'N';
		TurnOpen = 'N';
		
		addMouseListener(new MouseAdapter()
		{
			//	 void^ }EX̃NbNɔ
			public void mouseClicked(MouseEvent e)
			{
				if((e.getX() > L_x + 60) && (e.getX() < R_x)
					&& (e.getY() > y) && (e.getY() < y + 120))
				{
					ReadPermitTurnOpen();
					if(PermitTurnOpen == 'o')
					{
						TurnOpen = 'o';
						WriteTurnOpen();
					}
				}
				
				PermitTurnOpen = 'N';
				TurnOpen = 'N';
			}
		});
	}
	private void Safety()
	{
		try{
			while(true)
			{
				ReadSafety();
				if(Safety == 'r') break;
				else if(Safety == 'Y'){
					Thread.sleep(1000);
					ReadSafety();
					if(Safety == 'Y'){
						Safety = 'r';
						WriteSafety();
						break;
					}
				}
			}
		}
		catch(InterruptedException e){}
	}
	private void Limit()
	{
		try{
			ReadMotor();
			ReadLimit();
			switch(Motor)
			{
			case 's':
				if(Limit.equals("yynnyynndddd")){
					L_x = 60;
					R_x = 120;
					y = 480;
					repaint();
					Thread.sleep(1000);
				}
				else if(Limit.equals("yynnnnyydddd")){
					L_x = 0;
					R_x = 180;
					y = 480;
					repaint();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnnnyynnuudd")){
					L_x = 60;
					R_x = 120;
					y = 240;
					repaint();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnnnnnyyuudd")){
					L_x = 0;
					R_x = 180;
					y = 240;
					repaint();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnyyyynnuuuu")){
					L_x = 60;
					R_x = 120;
					y = 0;
					repaint();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnyynnyyuuuu")){
					L_x = 0;
					R_x = 180;
					y = 0;
					repaint();
					Thread.sleep(1000);
				}
				break;
			case 't':
				if(Limit.equals("yynnnnyydddd")){
					Limit = "yynnnnyndddd";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnnnnnyyuudd")){
					Limit = "nnnnnnynuudd";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnyynnyyuuuu")){
					Limit = "nnyynnynuuuu";
					WriteLimit();
					Thread.sleep(1000);
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'c':
				if(Limit.equals("yynnnnyndddd")){
					Limit = "yynnnnnndddd";
					WriteLimit();
					for(int j = 0; j < 15; j++){
						L_x = j;
						R_x = 180 - j;
						y = 480;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("yynnnynndddd")){
					Limit = "yynnyynndddd";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = j;
						R_x = 180 - j;
						y = 480;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("nnnnnnynuudd")){
					Limit = "nnnnnnnnuudd";
					WriteLimit();
					for(int j = 0; j < 15; j++){
						L_x = j;
						R_x = 180 - j;
						y = 240;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("nnnnnynnuudd")){
					Limit = "nnnnyynnuudd";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = j;
						R_x = 180 - j;
						y = 240;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("nnyynnynuuuu")){
					Limit = "nnyynnnnuuuu";
					WriteLimit();
					for(int j = 0; j < 15; j++){
						L_x = j;
						R_x = 180 - j;
						y = 0;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("nnyynynnuuuu")){
					Limit = "nnyyyynnuuuu";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = j;
						R_x = 180 - j;
						y = 0;
						repaint();
						Thread.sleep(66);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'C':
				if(Limit.equals("yynnnnnndddd")){
					Limit = "yynnnynndddd";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = j;
						R_x = 180 - j;
						y = 480;
						repaint();
						Thread.sleep(33);
					}
				}
				else if(Limit.equals("nnnnnnnnuudd")){
					Limit = "nnnnnynnuudd";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = j;
						R_x = 180 - j;
						y = 240;
						repaint();
						Thread.sleep(33);
					}
				}
				else if(Limit.equals("nnyynnnnuuuu")){
					Limit = "nnyynynnuuuu";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = j;
						R_x = 180 - j;
						y = 0;
						repaint();
						Thread.sleep(33);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'j':
				if(Limit.equals("yynnyynndddd")){
					Limit = "nynnyynndddd";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnnnyynnuudd")){
					Limit = "nnnnyynnuuud";
					WriteLimit();
					Thread.sleep(1000);
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'u':
				if(Limit.equals("nynnyynndddd")){
					Limit = "nnnnyynndddd";
					WriteLimit();
					for(int i = 480; i > 420; i--){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(16);
					}
				}
				else if(Limit.equals("nnnnyynnuddd")){
					Limit = "nnnnyynnuudd";
					WriteLimit();
					for(int i = 300; i > 240; i--){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(16);
					}
				}
				else if(Limit.equals("nnnnyynnuuud")){
					Limit = "nnnnyynnuuuu";
					WriteLimit();
					for(int i = 240; i > 180; i--){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(16);
					}
				}
				else if(Limit.equals("nnynyynnuuuu")){
					Limit = "nnyyyynnuuuu";
					WriteLimit();
					for(int i = 60; i > 0; i--){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(16);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'U':
				if(Limit.equals("nnnnyynndddd")){
					Limit = "nnnnyynnuddd";
					WriteLimit();
					for(int i = 420; i > 300; i--){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(8);
					}
				}
				else if(Limit.equals("nnnnyynnuddd")){
					Limit = "nnnnyynnuudd";
					WriteLimit();
					for(int i = 300; i > 240; i--){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(8);
					}
				}
				else if(Limit.equals("nnnnyynnuudd")){
					Limit = "nnnnyynnuuud";
					WriteLimit();
				}
				else if(Limit.equals("nnnnyynnuuud")){
					Limit = "nnnnyynnuuuu";
					WriteLimit();
					for(int i = 240; i > 180; i--){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(8);
					}
				}
				else if(Limit.equals("nnnnyynnuuuu")){
					Limit = "nnynyynnuuuu";
					WriteLimit();
					for(int i = 180; i > 60; i--){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(8);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'k':
				if(Limit.equals("nnyyyynnuuuu")){
					Limit = "nnynyynnuuuu";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnnnyynnuudd")){
					Limit = "nnnnyynnuddd";
					WriteLimit();
					Thread.sleep(1000);
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'd':
				if(Limit.equals("nnynyynnuuuu")){
					Limit = "nnnnyynnuuuu";
					WriteLimit();
					for(int i = 0; i < 60; i++){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(16);
					}
				}
				if(Limit.equals("nnnnyynnuuud")){
					Limit = "nnnnyynnuudd";
					WriteLimit();
					for(int i = 180; i < 240; i++){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(16);
					}
				}
				if(Limit.equals("nnnnyynnuddd")){
					Limit = "nnnnyynndddd";
					WriteLimit();
					for(int i = 240; i < 300; i++){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(16);
					}
				}
				else if(Limit.equals("nynnyynndddd")){
					Limit = "yynnyynndddd";
					WriteLimit();
					for(int i = 420; i < 480; i++){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(16);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'D':
				if(Limit.equals("nnnnyynnuuuu")){
					Limit = "nnnnyynnuuud";
					WriteLimit();
					for(int i = 60; i < 180; i++){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(8);
					}
				}
				else if(Limit.equals("nnnnyynnuuud")){
					Limit = "nnnnyynnuudd";
					WriteLimit();
					for(int i = 180; i < 240; i++){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(8);
					}
				}
				else if(Limit.equals("nnnnyynnuudd")){
					Limit = "nnnnyynnuddd";
					WriteLimit();
				}
				else if(Limit.equals("nnnnyynnuddd")){
					Limit = "nnnnyynndddd";
					WriteLimit();
					for(int i = 240; i < 300; i++){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(8);
					}
				}
				else if(Limit.equals("nnnnyynndddd")){
					Limit = "nynnyynndddd";
					WriteLimit();
					for(int i = 300; i < 420; i++){
						L_x = 60;
						R_x = 120;
						y = i;
						repaint();
						Thread.sleep(8);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'h':
				if(Limit.equals("nnyyyynnuuuu")){
					Limit = "nnyynynnuuuu";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnnnyynnuudd")){
					Limit = "nnnnnynnuudd";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("yynnyynndddd")){
					Limit = "yynnnynndddd";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnyynynnuuuu")){
					Limit = "nnyynnynuuuu";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 0;
						repaint();
						Thread.sleep(33);
					}
				}
				else if(Limit.equals("nnyynnnnuuuu")){
					Limit = "nnyynnyyuuuu";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 0;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("nnyynnynuuuu")){
					Limit = "nnyynnyyuuuu";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("nnnnnynnuudd")){
					Limit = "nnnnnnynuudd";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 240;
						repaint();
						Thread.sleep(33);
					}
				}
				else if(Limit.equals("nnnnnnnnuudd")){
					Limit = "nnnnnnyyuudd";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 240;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("nnnnnnynuudd")){
					Limit = "nnnnnnyyuudd";
					WriteLimit();
					Thread.sleep(1000);
				}
				else if(Limit.equals("yynnnynndddd")){
					Limit = "yynnnnyndddd";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 480;
						repaint();
						Thread.sleep(33);
					}
				}
				else if(Limit.equals("yynnnnnndddd")){
					Limit = "yynnnnyydddd";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 480;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("yynnnnyndddd")){
					Limit = "yynnnnyydddd";
					WriteLimit();
					Thread.sleep(1000);
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'o':
				if(Limit.equals("nnyynynnuuuu")){
					Limit = "nnyynnnnuuuu";
					WriteLimit();
					for(int j = 0; j < 15; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 0;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("nnyynnynuuuu")){
					Limit = "nnyynnyyuuuu";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 0;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("nnnnnynnuudd")){
					Limit = "nnnnnnnnuudd";
					WriteLimit();
					for(int j = 0; j < 15; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 240;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("nnnnnnynuudd")){
					Limit = "nnnnnnyyuudd";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 240;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("yynnnynndddd")){
					Limit = "yynnnnnndddd";
					WriteLimit();
					for(int j = 0; j < 15; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 480;
						repaint();
						Thread.sleep(66);
					}
				}
				else if(Limit.equals("yynnnnyndddd")){
					Limit = "yynnnnyydddd";
					WriteLimit();
					for(int j = 45; j < 60; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 480;
						repaint();
						Thread.sleep(66);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			case 'O':
				if(Limit.equals("nnyynnnnuuuu")){
					Limit = "nnyynnynuuuu";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 0;
						repaint();
						Thread.sleep(33);
					}
				}
				else if(Limit.equals("nnnnnnnnuudd")){
					Limit = "nnnnnnynuudd";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 240;
						repaint();
						Thread.sleep(33);
					}
				}
				else if(Limit.equals("yynnnnnndddd")){
					Limit = "yynnnnyndddd";
					WriteLimit();
					for(int j = 15; j < 45; j++){
						L_x = 60 - j;
						R_x = 120 + j;
						y = 480;
						repaint();
						Thread.sleep(33);
					}
				}
				else{
					Thread.sleep(1000);
				}
				break;
			default:
				Thread.sleep(1000);
				break;
			}
		}
		catch(InterruptedException e){}
	}
	public void run()
	{
		while(true)
		{
			Safety();
			Limit();
		}
	}
	public void paintComponent(Graphics g)
	{
		g.setColor(Color.green);
		g.fillRect(0, 0, width, height);
		g.setColor(Color.lightGray);
		g.fillRect(L_x + 60, y, R_x - L_x - 60, 120);
		g.setColor(Color.yellow);
		g.fillRect(L_x, y, 60, 120);
		g.fillRect(R_x, y, 60, 120);
		g.setColor(Color.black);
		g.drawRect(L_x + 60, y, R_x - L_x - 60, 120);
		g.drawRect(L_x, y, 60, 120);
		g.drawRect(R_x, y, 60, 120);
	}
	public void setmySize(int w, int h)
	{
		if(width > 0 && width < 1000)
		{
			width = w;
		}
		if(height > 0 && height < 500)
		{
			height = h;
		}
	}
	public void debug(int i)
	{
		System.out.println("Debug " + i);
	}
	private void ReadSafety()
	{
		Safety = EV_Simulator_JFile.Read(Safety, "Safety.txt");
	}
	private void WriteSafety()
	{
		EV_Simulator_JFile.Write(Safety, "Safety.txt");
	}
	private void ReadMotor()
	{
		Motor = EV_Simulator_JFile.Read(Motor, "Motor.txt");
	}
	private void ReadLimit()
	{
		Limit = EV_Simulator_JFile.Read(Limit, "Limit.txt");
	}
	private void WriteLimit()
	{
		EV_Simulator_JFile.Write(Limit, "Limit.txt");
	}
	private void ReadPermitTurnOpen()
	{
		PermitTurnOpen = EV_Simulator_JFile.Read(PermitTurnOpen, "PermitTurnOpen.txt");
	}
	private void WriteTurnOpen()
	{
		EV_Simulator_JFile.Write(TurnOpen, "TurnOpen.txt");
		EV_Simulator_JFile.Write("0o\0", "UserTurnOpen.txt");
	}
	public void Wait_ms(int ms)
	{
		try{
			Thread.sleep(ms);
		}
		catch(InterruptedException e){}
	}
}
