//	OpenClose.h

#ifndef Time_h
#define Time_h
#include "Time.h"
#endif

#ifndef File_h
#define File_h
#include "File.h"
#endif

#ifndef UpDown_h
#define UpDown_h
#include "UpDown.h"
#endif

using namespace Time;
using namespace File;
using namespace UpDown;

namespace OpenClose{
	//	Gx[^[݈̌ʒu
	class	Door{
		int		m_CLSL;
		int		m_CLST;
		int		m_OPSL;
		int		m_OPST;
	public:
		//	ʒu
		int		*p_CloserSlow;
		//	~ʒu
		int		*p_CloserStop;
		//	Jʒu
		int		*p_OpennerSlow;
		//	J~ʒu
		int		*p_OpennerStop;
		//	Sleepp
		int		fstop;
		int		*p_fstop;
		int		fmove;
		int		*p_fmove;
		Door();
	};

	//	J
	class	OpenMotor{
		CLimitFile	LF;
	public:
		//	J
		void	OnOpenMotor(Door *p_DR);
	};

	//	
	class	CloseMotor{
		CLimitFile	LF;
	public:
		//	
		void	OnCloseMotor(Door *p_DR);
		//	~
		void	OnStopCloseMotor(Door *p_DR);
	};

	//	Gx[^[̈ʒuzO
	class	WaitDoorChangeLog{
		CTurnOpenFile	TOF;
		char	chTurnOpen;
		char	*p_chTurnOpen;
		CLimitFile	LF;
		char	strLimit[LIMIT];
		char	*p_strLimit;
		//	Sleepp
		int		tmp;
	public:
		WaitDoorChangeLog();
		//	oߎ
		void	OnInitWaitDoorChangeLog(Door *p_DR);
		void	OnWaitOpenDoorChangeLog(Door *p_DR);
		void	OnWaitCloseDoorChangeLog(Door *p_DR);
		//	TurnOpenmF
		void	OnCheckTurnOpen(Position *p_P , Door *p_DR , int *p_TurnOpen);
	};

	class COpenClose{
	public:
		//	Gx[^[݈̌ʒuIuWFNg̐錾
		Door *p_DR;
		//	JIuWFNg̐錾
		OpenMotor OPMT;
		OpenMotor *p_OPMT;
		//	IuWFNg̐錾
		CloseMotor CLMT;
		CloseMotor *p_CLMT;
		//	Gx[^[̈ʒuzO
		WaitDoorChangeLog WDCL;
		WaitDoorChangeLog *p_WDCL;
		void InitOpenClose(Door *p_dr);
		//	J
		int	Open(CTimeOut *p_OpenTO);
		//	
		int	Close(Position *p_P, int *p_TurnOpen, CTimeOut *p_OpenTO);
	};
}
