//	Queue.cpp

#include "EV_Controller.h"
#include "Queue.h"

using namespace Time;
using namespace File;
using namespace UpDown;
using namespace OpenClose;

namespace Queue{
	void CQueue::Init(void){
		int i;
		p_strQueue = &strQueue[0];
		for(i = 0; i < 34; i++){
			strQueue[i] = 'N';
		}
		strQueue[34] = '\0';
		//	uYdyocHhqe0o0c0102031U2D2U3D2y2h0L\0
		//	NNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNNN\0
		UD = 'U';
		return;
	}
	void CQueue::Write(char *filename, char *p_str, char mode)
	{
		p_strLimit = &strLimit[0];
		F.ReadString("Limit.txt", p_strLimit, LIMIT);
		p_strQueue = &strQueue[0];
		if(filename[0] == 'C'){ // Command.txt
			switch(p_str[0]){
			case 'u':
				if(mode == 'w'){
					strQueue[0] = 'u';
				}
				else if(mode == 'r'){
					strQueue[0] = 'N';
				}
				break;
			case 'Y':
				if(mode == 'w'){
					strQueue[1] = 'Y';
				}
				else if(mode == 'r'){
					strQueue[1] = 'N';
				}
				break;
			case 'd':
				if(mode == 'w'){
					strQueue[2] = 'd';
				}
				else if(mode == 'r'){
					strQueue[2] = 'N';
				}
				break;
			case 'y':
				if(mode == 'w'){
					strQueue[3] = 'y';
				}
				else if(mode == 'r'){
					strQueue[3] = 'N';
				}
				break;
			case 'o':
				if(mode == 'w'){
					strQueue[4] = 'o';
				}
				else if(mode == 'r'){
					strQueue[4] = 'N';
				}
				break;
			case 'c':
				if(mode == 'w'){
					strQueue[5] = 'c';
				}
				else if(mode == 'r'){
					strQueue[5] = 'N';
				}
				break;
			case 'H':
				if(mode == 'w'){
					strQueue[6] = 'H';
				}
				else if(mode == 'r'){
					strQueue[6] = 'N';
				}
				break;
			case 'h':
				if(mode == 'w'){
					strQueue[7] = 'h';
				}
				else if(mode == 'r'){
					strQueue[7] = 'N';
				}
				break;
			case 'q':
				if(mode == 'w'){
					strQueue[8] = 'q';
				}
				else if(mode == 'r'){
					strQueue[8] = 'N';
				}
				break;
			case 'e':
				if(mode == 'w'){
					strQueue[9] = 'e';
				}
				else if(mode == 'r'){
					strQueue[9] = 'N';
				}
				break;
			default:
				break;
			}
		}
		else if(filename[0] == 'U'){ // UserCommand.txt
			switch(p_str[1]){
			case 'o':
				if(mode == 'w'){
					strQueue[10] = '0';
					strQueue[11] = 'o';
				}
				else if(mode == 'r'){
					strQueue[10] = 'N';
					strQueue[11] = 'N';
				}
				break;
			case 'c':
				if(mode == 'w'){
					strQueue[12] = '0';
					strQueue[13] = 'c';
				}
				else if(mode == 'r'){
					strQueue[12] = 'N';
					strQueue[13] = 'N';
				}
				break;
			case '1':
				if(mode == 'w'){
					if((strQueue[14] == '0') && (strQueue[15] == '1')){
						strQueue[14] = 'N';
						strQueue[15] = 'N';
						printf("1KsLZ\n");
					}
					else{
						strQueue[14] = '0';
						strQueue[15] = '1';
						printf("1KsON\n");
						
					}
				}
				else if(mode == 'r'){
					strQueue[14] = 'N';
					strQueue[15] = 'N';
				}
				break;
			case '2':
				if(mode == 'w'){
					if((strQueue[16] == '0') && (strQueue[17] == '2')){
						strQueue[16] = 'N';
						strQueue[17] = 'N';
						printf("2KsLZ\n");
					}
					else{
						strQueue[16] = '0';
						strQueue[17] = '2';
						printf("2KsON\n");
					}
				}
				else if(mode == 'r'){
					strQueue[16] = 'N';
					strQueue[17] = 'N';
				}
				break;
			case '3':
				if(mode == 'w'){
					if((strQueue[18] == '0') && (strQueue[19] == '3')){
						strQueue[18] = 'N';
						strQueue[19] = 'N';
						printf("3KsLZ\n");
					}
					else{
						strQueue[18] = '0';
						strQueue[19] = '3';
						printf("3KsON\n");
					}
				}
				else if(mode == 'r'){
					strQueue[18] = 'N';
					strQueue[19] = 'N';
				}
				break;
			case 'U':
				if(mode == 'w'){
					if(p_str[0] == '1'){
						if((strQueue[20] == '1') && (strQueue[21] == 'U')){
							strQueue[20] = 'N';
							strQueue[21] = 'N';
							printf("1KsLZ\n");
						}
						else{
							strQueue[20] = '1';
							strQueue[21] = 'U';
							printf("1KsON\n");
						}
					}
					else if(p_str[0] == '2'){
						if((strQueue[24] == '2') && (strQueue[25] == 'U')){
							strQueue[24] = 'N';
							strQueue[25] = 'N';
							printf("2KsLZ\n");
						}
						else{
							strQueue[24] = '2';
							strQueue[25] = 'U';
							printf("2KsON\n");
						}
					}
				}
				else if(mode == 'r'){
					if(p_str[0] == '1'){
						strQueue[20] = 'N';
						strQueue[21] = 'N';
					}
					else if(p_str[0] == '2'){
						strQueue[24] = 'N';
						strQueue[25] = 'N';
					}
				}
				break;
			case 'D':
				if(mode == 'w'){
					if(p_str[0] == '2'){
						if((strQueue[22] == '2') && (strQueue[23] == 'D')){
							strQueue[22] = 'N';
							strQueue[23] = 'N';
							printf("2K牺sLZ\n");
						}
						else{
							strQueue[22] = '2';
							strQueue[23] = 'D';
							printf("2K牺sON\n");
						}
					}
					else if(p_str[0] == '3'){
						if((strQueue[26] == '3') && (strQueue[27] == 'D')){
							strQueue[26] = 'N';
							strQueue[27] = 'N';
							printf("3K牺sLZ\n");
						}
						else{
							strQueue[26] = '3';
							strQueue[27] = 'D';
							printf("3K牺sON\n");
						}
						strQueue[26] = '3';
						strQueue[27] = 'D';
					}
				}
				else if(mode == 'r'){
					if(p_str[0] == '2'){
						strQueue[22] = 'N';
						strQueue[23] = 'N';
					}
					else if(p_str[0] == '3'){
						strQueue[26] = 'N';
						strQueue[27] = 'N';
					}
				}
				break;
			case 'y':
				if(mode == 'w'){
					if(p_str[0] == '2'){
						strQueue[28] = '2';
						strQueue[29] = 'y';
					}
				}
				else if(mode == 'r'){
					if(p_str[0] == '2'){
						strQueue[28] = 'N';
						strQueue[29] = 'N';
					}
				}
				break;
			case 'h':
				if(mode == 'w'){
					if(p_str[0] == '2'){
						strQueue[30] = '2';
						strQueue[31] = 'h';
					}
				}
				else if(mode == 'r'){
					if(p_str[0] == '2'){
						strQueue[30] = 'N';
						strQueue[31] = 'N';
					}
				}
				break;
			case 'L':
				if(mode == 'w'){
					if((strQueue[32] == '0') && (strQueue[33] == 'L')){
						strQueue[32] = 'N';
						strQueue[33] = 'N';
						printf("JLZ\n");
					}
					else if((p_strLimit[6] == 'y') && (p_strLimit[7] == 'y'))
					{
						strQueue[32] = '0';
						strQueue[33] = 'L';
						printf("JON\n");
					}
				}
				else if(mode == 'r'){
					strQueue[32] = 'N';
					strQueue[33] = 'N';
				}
				break;
			default:
				break;
			}
		}
		if(strQueue[0] == 'N' &&
			strQueue[1] == 'N' &&
			strQueue[2] == 'N' &&
			strQueue[3] == 'N' &&
			strQueue[4] == 'N' &&
			strQueue[5] == 'N' &&
			strQueue[6] == 'N' &&
			strQueue[7] == 'N' &&
			strQueue[8] == 'N' &&
			strQueue[9] == 'N' &&
			strQueue[10] == 'N' &&
			strQueue[11] == 'N' &&
			strQueue[12] == 'N' &&
			strQueue[13] == 'N' &&
			strQueue[14] == 'N' &&
			strQueue[15] == 'N' &&
			strQueue[16] == 'N' &&
			strQueue[17] == 'N' &&
			strQueue[18] == 'N' &&
			strQueue[19] == 'N' &&
			strQueue[20] == 'N' &&
			strQueue[21] == 'N' &&
			strQueue[22] == 'N' &&
			strQueue[23] == 'N' &&
			strQueue[24] == 'N' &&
			strQueue[25] == 'N' &&
			strQueue[26] == 'N' &&
			strQueue[27] == 'N' &&
			strQueue[28] == 'N' &&
			strQueue[29] == 'N' &&
			strQueue[30] == 'N' &&
			strQueue[31] == 'N' &&
			strQueue[32] == 'N' &&
			strQueue[33] == 'N')
		{
			if((p_strLimit[6] == 'y') && (p_strLimit[7] == 'y'))
			{
				F.Write("Motor.txt", 's');
			}
			else if((strQueue[32] == '0') && (strQueue[33] == 'L')){
				strQueue[32] = 'N';
				strQueue[33] = 'N';
			}
		}
		return;
	}
	int CQueue::Command_Read(char *p_Command){
		char ch;
		char *p_ch;
		char str[3];
		char *p_str;
		int i;

		p_strQueue = &strQueue[0];
		ch = 'N';
		p_ch = &ch;
		str[0] = 'N';
		str[1] = 'N';
		str[2] = '\n';
		p_str = &str[0];

		F.Read("Command.txt", p_ch);
		F.ReadString("UserCommand.txt", p_str, 3);

		//	write queue
		Write("Command.txt", p_ch, 'w');
		Write("UserCommand.txt", p_str, 'w');

		//	remove UserCommand.txt
		F.WriteString("UserCommand.txt", "NN\0");

		*p_Command = ch;
		if((ch == 'u') || (ch == 'Y') || (ch == 'd') || (ch == 'y')
		 || (ch == 'o') || (ch == 'c') || (ch == 'H') || (ch == 'h')
		 || (ch == 'e')){
			//	ߓ͋I
			F.Write("PermitCommand.txt", 'N');

	        //	ߐMێ
			T.WaitSecond(1);

			//	
			F.Write("Command.txt", 'N');

			//	remove queue
			Init();

			return OK;
		}
		else if(ch == 'q'){
			//	ߓ͋I
			F.Write("PermitCommand.txt", 'N');

	        //	ߐMێ
			T.WaitSecond(3);

			//	
			F.Write("Command.txt", 'N');
			F.WriteString("UserCommand.txt", "NN\0");

			//	remove queue
			Init();

			return OK;
		}
		return ONE_MORE_TIME;
	}
	int CQueue::CheckTurnOpen(void){
		int Ret;
		char strTurnOpen[3];
		char *p_strTurnOpen;
		char PermitTurnOpen;
		strTurnOpen[0] = 'N';
		strTurnOpen[0] = 'N';
		strTurnOpen[0] = '\0';
		PermitTurnOpen = 'N';
		p_strTurnOpen = &strTurnOpen[0];
		F.ReadString("UserTurnOpen.txt", p_strTurnOpen, 3);
		// Wait_ms(200);
		F.Read("PermitTurnOpen.txt", &PermitTurnOpen);
		// Wait_ms(200);
		if(PermitTurnOpen == 'N'){
			Ret = ONE_MORE_TIME;
		}
		else{
			//	f
			if(p_strTurnOpen[0] == 'N'){
				Ret = ONE_MORE_TIME;
			}
			else if((p_strTurnOpen[0] == '0') && (p_strTurnOpen[1] == 'o')){
				F.Write("Motor.txt", 'h');
				Write("UserCommand.txt", "0c\0", 'r');
				p_UserCommand[0] = '0';
				p_UserCommand[1] = 'o';
				printf("]J܂\n");
				F.WriteString("UserCommand.txt", "0o\0");
				F.Write("PermitCommand.txt", 'c');
				F.WriteString("UserTurnOpen.txt", "NN\0");
				F.Write("PermitTurnOpen.txt", 'N');
				T.WaitSecond(1);
				Ret = NG;
			}
			else if((p_strTurnOpen[0] == '0') && (p_strTurnOpen[1] == 'L')){
				F.Write("Motor.txt", 'h');
				Write("UserCommand.txt", "0c\0", 'r');
				p_UserCommand[0] = '0';
				p_UserCommand[1] = 'o';
				printf("]J܂\n");
				F.WriteString("UserCommand.txt", "0L\0");
				F.Write("PermitCommand.txt", 'c');
				F.WriteString("UserTurnOpen.txt", "NN\0");
				F.Write("PermitTurnOpen.txt", 'N');
				T.WaitSecond(1);
				Ret = NG;
			}
			else if((p_strLimit[0] == 'y') && ((p_strTurnOpen[0] == '1') || (p_strTurnOpen[1] == '1'))){
				F.Write("Motor.txt", 'h');
				Write("UserCommand.txt", "0c\0", 'r');
				p_UserCommand[0] = '0';
				p_UserCommand[1] = 'o';
				printf("]J܂\n");
				F.WriteString("UserCommand.txt", "0o\0");
				F.Write("PermitCommand.txt", 'c');
				F.WriteString("UserTurnOpen.txt", "NN\0");
				F.Write("PermitTurnOpen.txt", 'N');
				T.WaitSecond(1);
				Ret = NG;
			}
			else if((p_strLimit[9] == 'u') && (p_strLimit[10] == 'd') && ((p_strTurnOpen[0] == '2') || (p_strTurnOpen[1] == '2'))){
				F.Write("Motor.txt", 'h');
				Write("UserCommand.txt", "0c\0", 'r');
				Write("UserCommand.txt", "2h\0", 'r');
				p_UserCommand[0] = '0';
				p_UserCommand[1] = 'o';
				printf("]J܂\n");
				F.WriteString("UserCommand.txt", "0o\0");
				F.Write("PermitCommand.txt", 'c');
				F.WriteString("UserTurnOpen.txt", "NN\0");
				F.Write("PermitTurnOpen.txt", 'N');
				T.WaitSecond(1);
				Ret = NG;
			}
			else if((p_strLimit[3] == 'y') && ((p_strTurnOpen[0] == '3') || (p_strTurnOpen[1] == '3'))){
				F.Write("Motor.txt", 'h');
				Write("UserCommand.txt", "0c\0", 'r');
				p_UserCommand[0] = '0';
				p_UserCommand[1] = 'o';
				printf("]J܂\n");
				F.WriteString("UserCommand.txt", "0o\0");
				F.Write("PermitCommand.txt", 'c');
				F.WriteString("UserTurnOpen.txt", "NN\0");
				F.Write("PermitTurnOpen.txt", 'N');
				T.WaitSecond(1);
				Ret = NG;
			}
			else{
				Ret = ONE_MORE_TIME;
			}
		}
		return Ret;
	}
	int CQueue::Read(char *p_check){
		int Ret;
		p_strQueue = &strQueue[0];
		Ret = CheckTurnOpen();
		if(Ret == NG) return NG;
		switch(p_check[1]){
		case 'o':
			if(strQueue[11] == 'o'){
				p_UserCommand[0] = '0';
				p_UserCommand[1] = 'o';
				Ret = OK;
			}
			else{
				p_UserCommand[0] = 'N';
				p_UserCommand[1] = 'N';
				Ret = ONE_MORE_TIME;
			}
			break;
		case 'c':
			if(strQueue[13] == 'c'){
				p_UserCommand[0] = '0';
				p_UserCommand[1] = 'c';
				Ret = OK;
			}
			else{
				p_UserCommand[0] = 'N';
				p_UserCommand[1] = 'N';
				Ret = ONE_MORE_TIME;
			}
			break;
		case '1':
			if(strQueue[15] == '1'){
				p_UserCommand[0] = '0';
				p_UserCommand[1] = '1';
				Ret = OK;
			}
			else{
				p_UserCommand[0] = 'N';
				p_UserCommand[1] = 'N';
				Ret = ONE_MORE_TIME;
			}
			break;
		case '2':
			if(strQueue[17] == '2'){
				p_UserCommand[0] = '0';
				p_UserCommand[1] = '2';
				Ret = OK;
			}
			else{
				p_UserCommand[0] = 'N';
				p_UserCommand[1] = 'N';
				Ret = ONE_MORE_TIME;
			}
			break;
		case '3':
			if(strQueue[19] == '3'){
				p_UserCommand[0] = '0';
				p_UserCommand[1] = '3';
				Ret = OK;
			}
			else{
				p_UserCommand[0] = 'N';
				p_UserCommand[1] = 'N';
				Ret = ONE_MORE_TIME;
			}
			break;
		case 'U':
			if(p_check[0] == '1'){
				if(strQueue[21] == 'U'){
					p_UserCommand[0] = '1';
					p_UserCommand[1] = 'U';
					Ret = OK;
				}
				else{
					p_UserCommand[0] = 'N';
					p_UserCommand[1] = 'N';
					Ret = ONE_MORE_TIME;
				}
			}
			if(p_check[0] == '2'){
				if(strQueue[25] == 'U'){
					p_UserCommand[0] = '2';
					p_UserCommand[1] = 'U';
					Ret = OK;
				}
				else{
					p_UserCommand[0] = 'N';
					p_UserCommand[1] = 'N';
					Ret = ONE_MORE_TIME;
				}
			}
			break;
		case 'D':
			if(p_check[0] == '2'){
				if(strQueue[23] == 'D'){
					p_UserCommand[0] = '2';
					p_UserCommand[1] = 'D';
					Ret = OK;
				}
				else{
					p_UserCommand[0] = 'N';
					p_UserCommand[1] = 'N';
					Ret = ONE_MORE_TIME;
				}
			}
			if(p_check[0] == '3'){
				if(strQueue[27] == 'D'){
					p_UserCommand[0] = '3';
					p_UserCommand[1] = 'D';
					Ret = OK;
				}
				else{
					p_UserCommand[0] = 'N';
					p_UserCommand[1] = 'N';
					Ret = ONE_MORE_TIME;
				}
			}
			break;
		case 'y':
			if(p_check[0] == '2'){
				if(strQueue[29] == 'y'){
					p_UserCommand[0] = '2';
					p_UserCommand[1] = 'y';
					Ret = OK;
				}
				else{
					p_UserCommand[0] = 'N';
					p_UserCommand[1] = 'N';
					Ret = ONE_MORE_TIME;
				}
			}
			break;
		case 'h':
			if(p_check[0] == '2'){
				if(strQueue[31] == 'h'){
					p_UserCommand[0] = '2';
					p_UserCommand[1] = 'h';
					Ret = OK;
				}
				else{
					p_UserCommand[0] = 'N';
					p_UserCommand[1] = 'N';
					Ret = ONE_MORE_TIME;
				}
			}
			break;
		case 'L':
			if(strQueue[33] == 'L'){
				p_UserCommand[32] = '0';
				p_UserCommand[33] = 'L';
				Ret = OK;
			}
			else{
				p_UserCommand[32] = 'N';
				p_UserCommand[33] = 'N';
				Ret = ONE_MORE_TIME;
			}
			break;
		default:
			p_UserCommand[0] = 'N';
			p_UserCommand[1] = 'N';
			Ret = ONE_MORE_TIME;
			break;
		}
		return Ret;
	}
	int CQueue::Check(char *c0, char *c1, char *c2, char *c3, char *c4, char *c5, char *c6, char *c7, char *c8, char *c9, char *c10, char *c11){
		int Ret;
		Ret = Read(c0);
		if(Ret == OK) return OK;
		if(Ret == NG) return NG;
		Ret = Read( c1);
		if(Ret == OK) return OK;
		if(Ret == NG) return NG;
		Ret = Read(c2);
		if(Ret == OK) return OK;
		if(Ret == NG) return NG;
		Ret = Read(c3);
		if(Ret == OK) return OK;
		if(Ret == NG) return NG;
		Ret = Read(c4);
		if(Ret == OK) return OK;
		if(Ret == NG) return NG;
		Ret = Read(c5);
		if(Ret == OK) return OK;
		if(Ret == NG) return NG;
		Ret = Read(c6);
		if(Ret == OK) return OK;
		if(Ret == NG) return NG;
		Ret = Read(c7);
		if(Ret == OK) return OK;
		if(Ret == NG) return NG;
		Ret = Read(c8);
		if(Ret == OK) return OK;
		if(Ret == NG) return NG;
		Ret = Read(c9);
		if(Ret == OK) return OK;
		if(Ret == NG) return NG;
		Ret = Read(c10);
		if(Ret == OK) return OK;
		if(Ret == NG) return NG;
		Ret = Read(c11);
		return Ret;
	}
	int CQueue::Flow(void){
		int Ret;
		p_strLimit = &strLimit[0];
		p_chMotor = &chMotor;
		F.ReadString("Limit.txt", p_strLimit, LIMIT);
		Wait_ms(200);
		F.Read("Motor.txt", p_chMotor);
		Wait_ms(200);
		if((chMotor == 'j') || (chMotor == 'u') || (chMotor == 'U')){
			//	remove 0o,0c
			Write("UserCommand.txt", "0o\0", 'r');
			Write("UserCommand.txt", "0c\0", 'r');
			if((strLimit[9] == 'u') && (strLimit[10] == 'd') && ((chMotor == 'j') || (chMotor == 'u'))){
				//	02,2y,2U,03,3D,2D,01,1U
				Ret = Check("02\0","2y\0","2U\0","03\0","3D\0","2D\0","01\0","1U\0","NN\0","NN\0","NN\0","NN\0");
			}
			else if(strLimit[9] == 'u'){
				//	03,3D,02,2D,2y,01,1U,2U
				Ret = Check("03\0","3D\0","02\0","2D\0","2y\0","01\0","1U\0","2U\0","NN\0","NN\0","NN\0","NN\0");
			}
			else{
				//	02,2U,2y,03,3D,2D,01,1U
				Ret = Check("02\0","2U\0","2y\0","03\0","3D\0","2D\0","01\0","1U\0","NN\0","NN\0","NN\0","NN\0");
			}
		}
		else if((chMotor == 'k') || (chMotor == 'd') || (chMotor == 'D')){
			//	remove 0o,0c
			Write("UserCommand.txt", "0o\0", 'r');
			Write("UserCommand.txt", "0c\0", 'r');
			if((strLimit[9] == 'u') && (strLimit[10] == 'd') && ((chMotor == 'k') || (chMotor == 'd'))){
				//	02,2y,2D,01,1U,2U,03,3D
				Ret = Check("02\0","2y\0","2D\0","01\0","1U\0","2U\0","03\0","3D\0","NN\0","NN\0","NN\0","NN\0");
			}
			else if(strLimit[10] == 'd'){
				//	01,1U,02,2U,2y,03,3D,2D
				Ret = Check("01\0","1U\0","02\0","2U\0","2y\0","03\0","3D\0","2D\0","NN\0","NN\0","NN\0","NN\0");
			}
			else{
				//	02,2D,2y,01,1U,2U,03,3D
				Ret = Check("02\0","2D\0","2y\0","01\0","1U\0","2U\0","03\0","3D\0","NN\0","NN\0","NN\0","NN\0");
			}
		}
		else if((chMotor == 'h') || (chMotor == 'o') || (chMotor == 'O')){
			if(strLimit[0] == 'y'){
				//	0L,0o,01,1U,0c,02,2U,03,3D,2D
				Ret = Check("0L\0","0o\0","01\0","1U\0","0c\0","02\0","2U\0","03\0","3D\0","2D\0","NN\0","NN\0");
			}
			else if((strLimit[9] == 'u') && (strLimit[10] == 'd')){
				//	0L,0o,02,2D/2U,2y,0c,01/03,1U/3D
				Ret = Check("0L\0","0o\0","02\0","2D\0","2U\0","2y\0","0c\0","01\0","03\0","1U\0","3D\0","NN\0");
			}
			else if(strLimit[3] == 'y'){
				//	0L,0o,03,3D,0c,02,2D,01,1U,2U
				Ret = Check("0L\0","0o\0","03\0","3D\0","0c\0","02\0","2D\0","01\0","1U\0","2U\0","NN\0","NN\0");
			}
		}
		else if((chMotor == 't') || (chMotor == 'c') || (chMotor == 'C')){
			if(strLimit[0] == 'y'){
				//	0L,0o,01,1U,0c,02,2U,03,3D,2D
				Ret = Check("0L\0","0o\0","01\0","1U\0","0c\0","02\0","2U\0","03\0","3D\0","2D\0","NN\0","NN\0");
			}
			else if((strLimit[9] == 'u') && (strLimit[10] == 'd')){
				//	0L,0o,02,2D/2U,2y,0c,2h,01/03,1U/3D
				//	Ret = Check("0L\0","0o\0","02\0","2D\0","2U\0","2y\0","0c\0","2h\0","01\0","03\0","1U\0","3D\0");
				if(UD == 'U')
				{
					//	0L,0o,02,2U,2y,0c,2h,03,3D,2D,01,1U
					Ret = Check("0L\0","0o\0","02\0","2U\0","2y\0","0c\0","2h\0","03\0","3D\0","2D\0","01\0","1U\0");
				}
				else if(UD == 'D')
				{
					//	0L,0o,02,2D,2y,0c,2h,01,1U,2U,03,3D
					Ret = Check("0L\0","0o\0","02\0","2D\0","2y\0","0c\0","2h\0","01\0","1U\0","2U\0","03\0","3D\0");
				}
			}
			else if(strLimit[3] == 'y'){
				//	0L,0o,03,3D,0c,02,2D,01,1U,2U
				Ret = Check("0L\0","0o\0","03\0","3D\0","0c\0","02\0","2D\0","01\0","1U\0","2U\0","NN\0","NN\0");
			}
		}
		else if(chMotor == 's'){
			if(strLimit[0] == 'y'){
				if(strLimit[7] == 'y'){ // 1J
					//	remove 0o,01,1U
					Write("UserCommand.txt", "0o\0", 'r');
					Write("UserCommand.txt", "01\0", 'r');
					Write("UserCommand.txt", "1U\0", 'r');
					//	0L,0c,02,2U,03,3D,2D
					// Ret = Check("0L\0","0c\0","02\0","2U\0","03\0","3D\0","2D\0","NN\0","NN\0","NN\0","NN\0","NN\0");
					//	0L,0c
					Ret = Check("0L\0","0c\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0");
				}
				else if(strLimit[4] == 'y'){ // 1
					//	remove 0c
					Write("UserCommand.txt", "0c\0", 'r');
					//	0L,0o,01,1U,02,2U,2y,03,3D,2D
					Ret = Check("0L\0","0o\0","01\0","1U\0","02\0","2U\0","2y\0","03\0","3D\0","2D\0","NN\0","NN\0");
				}
				else{
					//	0L,0o,01,1U,0c,02,2U,03,3D,2D
					Ret = Check("0L\0","0o\0","01\0","1U\0","0c\0","02\0","2U\0","03\0","3D\0","2D\0","NN\0","NN\0");
				}
			}
			else if((strLimit[9] == 'u') && (strLimit[10] == 'd'))
			{
				if(strLimit[7] == 'y'){ // 2J
					//	remove 0o,02,2U,2D
					Write("UserCommand.txt", "0o\0", 'r');
					Write("UserCommand.txt", "02\0", 'r');
					if(UD == 'U')
					{
						Write("UserCommand.txt", "2U\0", 'r');
						//	0L,0o,02,2U,2y,0c,2h,03,3D
						Ret = Check("0L\0","0o\0","02\0","2U\0","2y\0","0c\0","2h\0","03\0","3D\0","NN\0","NN\0","NN\0");
						if(Ret == ONE_MORE_TIME)
						{
							Write("UserCommand.txt", "2D\0", 'r');
						}
					}
					else if(UD == 'D')
					{
						Write("UserCommand.txt", "2D\0", 'r');
						//	0L,0o,02,2D,2y,0c,2h,01,1U
						Ret = Check("0L\0","0o\0","02\0","2D\0","2y\0","0c\0","2h\0","01\0","1U\0","NN\0","NN\0","NN\0");
						if(Ret == ONE_MORE_TIME)
						{
							Write("UserCommand.txt", "2U\0", 'r');
						}
					}
					Write("UserCommand.txt", "2y\0", 'r');
					//	0L,0c,2h,01/03,1U/3D
					// Ret = Check("0L\0","0c\0","2h\0","01\0","03\0","1U\0","3D\0","NN\0","NN\0","NN\0","NN\0","NN\0");
					//	0L,0c
					Ret = Check("0L\0","0c\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0");
				}
				else if(strLimit[4] == 'y'){ // 2
					//	remove 0c,2h
					Write("UserCommand.txt", "0c\0", 'r');
					Write("UserCommand.txt", "2h\0", 'r');
					//	0L,0o,02,2D/2U,2y,01/03,1U/3D
					//	Ret = Check("0L\0","0o\0","02\0","2D\0","2U\0","2y\0","01\0","03\0","1U\0","3D\0","NN\0","NN\0");
					if(UD == 'U')
					{
						//	0L,0o,02,2U,2y,03,3D,2D,01,1U
						Ret = Check("0L\0","0o\0","02\0","2U\0","2y\0","03\0","3D\0","2D\0","01\0","1U\0","NN\0","NN\0");
					}
					else if(UD == 'D')
					{
						//	0L,0o,02,2D,2y,01,1U,2U,03,3D
						Ret = Check("0L\0","0o\0","02\0","2D\0","2y\0","01\0","1U\0","2U\0","03\0","3D\0","NN\0","NN\0");
					}
				}
				else{
					//	0L,0o,02,2D/2U,2y,0c,2h,01/03,1U/3D
					Ret = Check("0L\0","0o\0","02\0","2D\0","2U\0","2y\0","0c\0","2h\0","01\0","03\0","1U\0","3D\0");
				}
			}
			else if(strLimit[3] == 'y'){
				if(strLimit[7] == 'y'){ // 3J
					//	remove 0o,03,3D
					Write("UserCommand.txt", "0o\0", 'r');
					Write("UserCommand.txt", "03\0", 'r');
					Write("UserCommand.txt", "3D\0", 'r');
					//	0L,0c,02,2D,01,1U,2U
					// Ret = Check("0L\0","0c\0","02\0","2D\0","01\0","1U\0","2U\0","NN\0","NN\0","NN\0","NN\0","NN\0");
					//	0L,0c
					Ret = Check("0L\0","0c\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0");
				}
				else if(strLimit[4] == 'y'){ // 3
					//	remove 0c
					Write("UserCommand.txt", "0c\0", 'r');
					//	0L,0o,03,3D,02,2D,2y,01,1U,2U
					Ret = Check("0L\0","0o\0","03\0","3D\0","02\0","2D\0","2y\0","01\0","1U\0","2U\0","NN\0","NN\0");
				}
				else{
					//	0L,0o,03,3D,0c,02,2D,01,1U,2U
					Ret = Check("0L\0","0o\0","03\0","3D\0","0c\0","02\0","2D\0","01\0","1U\0","2U\0","NN\0","NN\0");
				}
			}
			else if(strLimit[9] == 'd'){
				//	remove 0o,0c
				Write("UserCommand.txt", "0o\0", 'r');
				Write("UserCommand.txt", "0c\0", 'r');
				//	0L,01/02,1U/2U,2y,03,3D,2D
				Ret = Check("0L\0","01\0","02\0","1U\0","2U\0","2y\0","03\0","3D\0","2D\0","NN\0","NN\0","NN\0");
			}
			else if(strLimit[10] == 'u'){
				//	remove 0o,0c
				Write("UserCommand.txt", "0o\0", 'r');
				Write("UserCommand.txt", "0c\0", 'r');
				//	0L,03/02,3D/2D,2y,01,1U,2U
				Ret = Check("0L\0","03\0","02\0","3D\0","2D\0","2y\0","01\0","1U\0","2U\0","NN\0","NN\0","NN\0");
			}
		}
		return Ret;
	}
	void CQueue::Motor(CTimeOut *p_OpenTO){
		int FlowRet;
		char UserCommand[3];
		UserCommand[0] = 'N';
		UserCommand[1] = 'N';
		UserCommand[2] = '\0';
		p_UserCommand = &UserCommand[0];
		p_strLimit = &strLimit[0];
		p_chMotor = &chMotor;
		F.ReadString("Limit.txt", p_strLimit, LIMIT);
		F.Read("Motor.txt", p_chMotor);
		p_tOpenTO = p_OpenTO;
		FlowRet = Flow();
		if(FlowRet == OK){
			if(strLimit[0] == 'y'){
				if(strLimit[4] == 'y'){ // 1
					UD = 'U';
					switch(UserCommand[1]){
					case 'U':
						if(UserCommand[0] == '1'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							T.WaitSecond(1);
							F.Write("Motor.txt", 'h');
							printf("J܂\n");
							T.WaitSecond(1);
						}
						else if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							F.Write("PermitTurnOpen.txt", 'N');
							T.WaitSecond(1);
							F.Write("Motor.txt", 'j');
							printf("㏸܂\n");
							T.WaitSecond(1);
						}
						break;
					case 'D':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							F.Write("PermitTurnOpen.txt", 'N');
							T.WaitSecond(1);
							F.Write("Motor.txt", 'j');
							printf("㏸܂\n");
							T.WaitSecond(1);
						}
						else if(UserCommand[0] == '3'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							F.Write("PermitTurnOpen.txt", 'N');
							T.WaitSecond(1);
							F.Write("Motor.txt", 'j');
							printf("㏸܂\n");
							T.WaitSecond(1);
						}
						break;
					case 'y':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							F.Write("PermitTurnOpen.txt", 'N');
							T.WaitSecond(1);
							F.Write("Motor.txt", 'j');
							printf("㏸܂\n");
							T.WaitSecond(1);
						}
						break;
					case 'o':
					case 'L':
					case '1':
						F.Write("Motor.txt", 's');
						printf("STOP܂\n");
						T.WaitSecond(1);
						F.Write("Motor.txt", 'h');
						printf("J܂\n");
						T.WaitSecond(1);
						break;
					case '2':
					case '3':
						F.Write("Motor.txt", 's');
						printf("STOP܂\n");
						F.Write("PermitTurnOpen.txt", 'N');
						T.WaitSecond(1);
						F.Write("Motor.txt", 'j');
						printf("㏸܂\n");
						T.WaitSecond(1);
						break;
					case 'c':
						F.Write("Motor.txt", 's');
						printf("STOP܂\n");
						F.Write("PermitTurnOpen.txt", 'N');
						T.WaitSecond(1);
						break;
					default:
						break;
					}
				}
				else if(strLimit[7] == 'y'){ // 1J
					switch(UserCommand[1]){
					case 'U':
						if(UserCommand[0] == '1'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							//	݊J
							printf("JĂ܂\n");
							p_OpenTO->SetCurrentTime();
							p_OpenTO->SetPermit(ON);
							T.WaitSecond(1);
						}
						else if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 't');
							printf("܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							p_OpenTO->SetPermit(OFF);
							T.WaitSecond(1);
						}
						break;
					case 'D':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 't');
							printf("܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							p_OpenTO->SetPermit(OFF);
							T.WaitSecond(1);
						}
						else if(UserCommand[0] == '3'){
							F.Write("Motor.txt", 't');
							printf("܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							p_OpenTO->SetPermit(OFF);
							T.WaitSecond(1);
						}
						break;
					case 'o':
					case 'L':
					case '1':
						F.Write("Motor.txt", 's');
						printf("STOP܂\n");
						//	݊J
						printf("JĂ܂\n");
						p_OpenTO->SetCurrentTime();
						p_OpenTO->SetPermit(ON);
						T.WaitSecond(1);
						break;
					case 'c':
					case '2':
					case '3':
						F.Write("Motor.txt", 't');
						printf("܂\n");
						F.Write("PermitTurnOpen.txt", 'o');
						p_OpenTO->SetPermit(OFF);
						T.WaitSecond(1);
						break;
					default:
						break;
					}
				}
				else if((strLimit[5] == 'y') || (strLimit[6] == 'y')){
					switch(UserCommand[1]){
					case 'U':
						if(UserCommand[0] == '1'){
							F.Write("Motor.txt", 'o');
							printf("OPEN܂\n");
							T.WaitSecond(1);
						}
						else{
							F.Write("Motor.txt", 'c');
							printf("CLOSE܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							T.WaitSecond(1);
						}
						break;
					case 'o':
					case 'L':
					case '1':
						F.Write("Motor.txt", 'o');
						printf("OPEN܂\n");
						T.WaitSecond(1);
						break;
					default:
						F.Write("Motor.txt", 'c');
						printf("CLOSE܂\n");
						F.Write("PermitTurnOpen.txt", 'o');
						T.WaitSecond(1);
						break;
					}
				}
				else{
					switch(UserCommand[1]){
					case 'U':
						if(UserCommand[0] == '1'){
							F.Write("Motor.txt", 'O');
							printf("OPEN܂\n");
							T.WaitSecond(1);
						}
						else{
							F.Write("Motor.txt", 'C');
							printf("CLOSE܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							T.WaitSecond(1);
						}
						break;
					case 'o':
					case 'L':
					case '1':
						F.Write("Motor.txt", 'O');
						printf("OPEN܂\n");
						T.WaitSecond(1);
						break;
					default:
						F.Write("Motor.txt", 'C');
						printf("CLOSE܂\n");
						F.Write("PermitTurnOpen.txt", 'o');
						T.WaitSecond(1);
						break;
					}
				}
			}
			else if((strLimit[9] == 'u') && (strLimit[10] == 'd')){
				if(strLimit[4] == 'y'){ // 2
					switch(UserCommand[1]){
					case 'U':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							T.WaitSecond(1);
							F.Write("Motor.txt", 'h');
							printf("J܂\n");
							T.WaitSecond(1);
						}
						else if(UserCommand[0] == '1'){
							UD = 'D';
							if(chMotor == 'D'){
								F.Write("Motor.txt", 'D');
								printf("DOWN܂\n");
								T.WaitSecond(1);
							}
							else{
								F.Write("Motor.txt", 's');
								printf("STOP܂\n");
								F.Write("PermitTurnOpen.txt", 'N');
								T.WaitSecond(1);
								F.Write("Motor.txt", 'k');
								printf("~܂\n");
								T.WaitSecond(1);
							}
						}
						break;
					case 'D':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							T.WaitSecond(1);
							F.Write("Motor.txt", 'h');
							printf("J܂\n");
							T.WaitSecond(1);
						}
						else if(UserCommand[0] == '3'){
							UD = 'U';
							if(chMotor == 'U'){
								F.Write("Motor.txt", 'U');
								printf("UP܂\n");
								T.WaitSecond(1);
							}
							else{
								F.Write("Motor.txt", 's');
								printf("STOP܂\n");
								F.Write("PermitTurnOpen.txt", 'N');
								T.WaitSecond(1);
								F.Write("Motor.txt", 'j');
								printf("㏸܂\n");
								T.WaitSecond(1);
							}
						}
						break;
					case 'y':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							T.WaitSecond(1);
							F.Write("Motor.txt", 'h');
							printf("J܂\n");
							T.WaitSecond(1);
						}
						break;
					case 'o':
					case 'L':
					case '2':
						F.Write("Motor.txt", 's');
						printf("STOP܂\n");
						T.WaitSecond(1);
						F.Write("Motor.txt", 'h');
						printf("J܂\n");
						T.WaitSecond(1);
						break;
					case '1':
						UD = 'D';
						if(chMotor == 'D'){
							F.Write("Motor.txt", 'D');
							printf("DOWN܂\n");
							T.WaitSecond(1);
						}
						else{
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							F.Write("PermitTurnOpen.txt", 'N');
							T.WaitSecond(1);
							F.Write("Motor.txt", 'k');
							printf("~܂\n");
							T.WaitSecond(1);
						}
						break;
					case '3':
						UD = 'U';
						if(chMotor == 'U'){
							F.Write("Motor.txt", 'U');
							printf("UP܂\n");
							T.WaitSecond(1);
						}
						else{
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							F.Write("PermitTurnOpen.txt", 'N');
							T.WaitSecond(1);
							F.Write("Motor.txt", 'j');
							printf("㏸܂\n");
							T.WaitSecond(1);
						}
						break;
					case 'c':
						F.Write("Motor.txt", 's');
						printf("STOP܂\n");
						F.Write("PermitTurnOpen.txt", 'N');
						T.WaitSecond(1);
						break;
					case 'h':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							F.Write("PermitTurnOpen.txt", 'N');
							T.WaitSecond(1);
						}
						break;
					default:
						break;
					}
				}
				else if(strLimit[7] == 'y'){ // 2J
					switch(UserCommand[1]){
					case 'U':
					case 'D':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							//	݊J
							printf("JĂ܂\n");
							p_OpenTO->SetCurrentTime();
							p_OpenTO->SetPermit(ON);
							T.WaitSecond(1);
						}
						else{
							F.Write("Motor.txt", 't');
							printf("܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							p_OpenTO->SetPermit(OFF);
							T.WaitSecond(1);
						}
						break;
					case 'y':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							//	݊J
							printf("JĂ܂\n");
							p_OpenTO->SetCurrentTime();
							p_OpenTO->SetPermit(ON);
							T.WaitSecond(1);
						}
						break;
					case 'o':
					case 'L':
					case '2':
						F.Write("Motor.txt", 's');
						printf("STOP܂\n");
						//	݊J
						printf("JĂ܂\n");
						p_OpenTO->SetCurrentTime();
						p_OpenTO->SetPermit(ON);
						T.WaitSecond(1);
						break;
					case 'c':
					case '1':
					case '3':
						F.Write("Motor.txt", 't');
						printf("܂\n");
						F.Write("PermitTurnOpen.txt", 'o');
						p_OpenTO->SetPermit(OFF);
						T.WaitSecond(1);
						break;
					case 'h':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 't');
							printf("܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							p_OpenTO->SetPermit(OFF);
							T.WaitSecond(1);
						}
						break;
					default:
						break;
					}
				}
				else if((strLimit[5] == 'y') || (strLimit[6] == 'y')){
					switch(UserCommand[1]){
					case 'U':
					case 'D':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 'o');
							printf("OPEN܂\n");
							T.WaitSecond(1);
						}
						else{
							F.Write("Motor.txt", 'c');
							printf("CLOSE܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							T.WaitSecond(1);
						}
						break;
					case 'y':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 'o');
							printf("OPEN܂\n");
							T.WaitSecond(1);
						}
						break;
					case 'o':
					case 'L':
					case '2':
						F.Write("Motor.txt", 'o');
						printf("OPEN܂\n");
						T.WaitSecond(1);
						break;
					default:
						F.Write("Motor.txt", 'c');
						printf("CLOSE܂\n");
						F.Write("PermitTurnOpen.txt", 'o');
						T.WaitSecond(1);
						break;
					}
				}
				else{
					switch(UserCommand[1]){
					case 'U':
					case 'D':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 'O');
							printf("OPEN܂\n");
							T.WaitSecond(1);
						}
						else{
							F.Write("Motor.txt", 'C');
							printf("CLOSE܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							T.WaitSecond(1);
						}
						break;
					case 'y':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 'O');
							printf("OPEN܂\n");
							T.WaitSecond(1);
						}
						break;
					case 'o':
					case 'L':
					case '2':
						F.Write("Motor.txt", 'O');
						printf("OPEN܂\n");
						T.WaitSecond(1);
						break;
					default:
						F.Write("Motor.txt", 'C');
						printf("CLOSE܂\n");
						F.Write("PermitTurnOpen.txt", 'o');
						T.WaitSecond(1);
						break;
					}
				}
			}
			else if(strLimit[3] == 'y'){
				if(strLimit[4] == 'y'){ // 3
					UD = 'D';
					switch(UserCommand[1]){
					case 'U':
						if(UserCommand[0] == '1'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							F.Write("PermitTurnOpen.txt", 'N');
							T.WaitSecond(1);
							F.Write("Motor.txt", 'k');
							printf("~܂\n");
							T.WaitSecond(1);
						}
						else if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							F.Write("PermitTurnOpen.txt", 'N');
							T.WaitSecond(1);
							F.Write("Motor.txt", 'k');
							printf("~܂\n");
							T.WaitSecond(1);
						}
						break;
					case 'D':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							F.Write("PermitTurnOpen.txt", 'N');
							T.WaitSecond(1);
							F.Write("Motor.txt", 'k');
							printf("~܂\n");
							T.WaitSecond(1);
						}
						else if(UserCommand[0] == '3'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							F.Write("PermitTurnOpen.txt", 'N');
							T.WaitSecond(1);
							F.Write("Motor.txt", 'h');
							printf("J܂\n");
							T.WaitSecond(1);
						}
						break;
					case 'y':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							F.Write("PermitTurnOpen.txt", 'N');
							T.WaitSecond(1);
							F.Write("Motor.txt", 'k');
							printf("~܂\n");
							T.WaitSecond(1);
						}
						break;
					case 'o':
					case 'L':
					case '3':
						F.Write("Motor.txt", 's');
						printf("STOP܂\n");
						F.Write("PermitTurnOpen.txt", 'N');
						T.WaitSecond(1);
						F.Write("Motor.txt", 'h');
						printf("J܂\n");
						T.WaitSecond(1);
						break;
					case '1':
					case '2':
						F.Write("Motor.txt", 's');
						printf("STOP܂\n");
						F.Write("PermitTurnOpen.txt", 'N');
						T.WaitSecond(1);
						F.Write("Motor.txt", 'k');
						printf("~܂\n");
						T.WaitSecond(1);
						break;
					case 'c':
						F.Write("Motor.txt", 's');
						printf("STOP܂\n");
						F.Write("PermitTurnOpen.txt", 'o');
						T.WaitSecond(1);
						break;
					default:
						break;
					}
				}
				else if(strLimit[7] == 'y'){ // 3J
					switch(UserCommand[1]){
					case 'U':
						if(UserCommand[0] == '1'){
							F.Write("Motor.txt", 't');
							printf("܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							p_OpenTO->SetPermit(OFF);
							T.WaitSecond(1);
						}
						else if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 't');
							printf("܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							p_OpenTO->SetPermit(OFF);
							T.WaitSecond(1);
						}
						break;
					case 'D':
						if(UserCommand[0] == '2'){
							F.Write("Motor.txt", 't');
							printf("܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							p_OpenTO->SetPermit(OFF);
							T.WaitSecond(1);
						}
						else if(UserCommand[0] == '3'){
							F.Write("Motor.txt", 's');
							printf("STOP܂\n");
							//	݊J
							printf("JĂ܂\n");
							p_OpenTO->SetCurrentTime();
							p_OpenTO->SetPermit(ON);
							T.WaitSecond(1);
						}
						break;
					case 'o':
					case 'L':
					case '3':
						F.Write("Motor.txt", 's');
						printf("STOP܂\n");
						//	݊J
						printf("JĂ܂\n");
						p_OpenTO->SetCurrentTime();
						p_OpenTO->SetPermit(ON);
						T.WaitSecond(1);
						break;
					case 'c':
					case '1':
					case '2':
						F.Write("Motor.txt", 't');
						printf("܂\n");
						F.Write("PermitTurnOpen.txt", 'o');
						p_OpenTO->SetPermit(OFF);
						T.WaitSecond(1);
						break;
					default:
						break;
					}
				}
				else if((strLimit[5] == 'y') || (strLimit[6] == 'y')){
					switch(UserCommand[1]){
					case 'D':
						if(UserCommand[0] == '3'){
							F.Write("Motor.txt", 'o');
							printf("OPEN܂\n");
							T.WaitSecond(1);
						}
						else{
							F.Write("Motor.txt", 'c');
							printf("CLOSE܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							T.WaitSecond(1);
						}
						break;
					case 'o':
					case 'L':
					case '3':
						F.Write("Motor.txt", 'o');
						printf("OPEN܂\n");
						T.WaitSecond(1);
						break;
					default:
						F.Write("Motor.txt", 'c');
						printf("CLOSE܂\n");
						F.Write("PermitTurnOpen.txt", 'o');
						T.WaitSecond(1);
						break;
					}
				}
				else{
					switch(UserCommand[1]){
					case 'D':
						if(UserCommand[0] == '3'){
							F.Write("Motor.txt", 'O');
							printf("OPEN܂\n");
							T.WaitSecond(1);
						}
						else{
							F.Write("Motor.txt", 'C');
							printf("CLOSE܂\n");
							F.Write("PermitTurnOpen.txt", 'o');
							T.WaitSecond(1);
						}
						break;
					case 'o':
					case 'L':
					case '3':
						F.Write("Motor.txt", 'O');
						printf("OPEN܂\n");
						T.WaitSecond(1);
						break;
					default:
						F.Write("Motor.txt", 'C');
						printf("CLOSE܂\n");
						F.Write("PermitTurnOpen.txt", 'o');
						T.WaitSecond(1);
						break;
					}
				}
			}
			else if(strLimit[1] == 'y'){
				switch(UserCommand[1]){
				case 'U':
					if(UserCommand[0] == '1'){
						F.Write("Motor.txt", 'd');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					else if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'u');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					break;
				case 'D':
					if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'u');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					else if(UserCommand[0] == '3'){
						F.Write("Motor.txt", 'u');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					break;
				case 'y':
					if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'u');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					break;
				case '1':
					F.Write("Motor.txt", 'd');
					printf("DOWN܂\n");
					T.WaitSecond(1);
					break;
				case '2':
				case '3':
					F.Write("Motor.txt", 'u');
					printf("UP܂\n");
					T.WaitSecond(1);
					break;
				default:
					break;
				}
			}
			else if(strLimit[8] == 'd'){
				switch(UserCommand[1]){
				case 'U':
					if(UserCommand[0] == '1'){
						F.Write("Motor.txt", 'D');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					else if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'U');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					break;
				case 'D':
					if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'U');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					else if(UserCommand[0] == '3'){
						F.Write("Motor.txt", 'U');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					break;
				case 'y':
					if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'U');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					break;
				case '1':
					F.Write("Motor.txt", 'D');
					printf("DOWN܂\n");
					T.WaitSecond(1);
					break;
				case '2':
				case '3':
					F.Write("Motor.txt", 'U');
					printf("UP܂\n");
					T.WaitSecond(1);
					break;
				default:
					break;
				}
			}
			else if(strLimit[9] == 'd'){
				switch(UserCommand[1]){
				case 'U':
					if(UserCommand[0] == '1'){
						F.Write("Motor.txt", 'd');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					else if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'u');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					break;
				case 'D':
					if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'u');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					else if(UserCommand[0] == '3'){
						F.Write("Motor.txt", 'U');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					break;
				case 'y':
					if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'u');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					break;
				case '1':
					F.Write("Motor.txt", 'd');
					printf("DOWN܂\n");
					T.WaitSecond(1);
					break;
				case '2':
					F.Write("Motor.txt", 'u');
					printf("UP܂\n");
					T.WaitSecond(1);
					break;
				case '3':
					F.Write("Motor.txt", 'U');
					printf("UP܂\n");
					T.WaitSecond(1);
					break;
				default:
					break;
				}
			}
			else if((strLimit[10] == 'u') && (strLimit[11] == 'd')){
				switch(UserCommand[1]){
				case 'U':
					if(UserCommand[0] == '1'){
						F.Write("Motor.txt", 'D');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					else if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'd');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					break;
				case 'D':
					if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'd');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					else if(UserCommand[0] == '3'){
						F.Write("Motor.txt", 'u');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					break;
				case 'y':
					if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'd');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					break;
				case '1':
					F.Write("Motor.txt", 'D');
					printf("DOWN܂\n");
					T.WaitSecond(1);
					break;
				case '2':
					F.Write("Motor.txt", 'd');
					printf("DOWN܂\n");
					T.WaitSecond(1);
					break;
				case '3':
					F.Write("Motor.txt", 'u');
					printf("UP܂\n");
					T.WaitSecond(1);
					break;
				default:
					break;
				}
			}
			else if((strLimit[11] == 'u') && (strLimit[2] == 'n')){
				switch(UserCommand[1]){
				case 'U':
					if(UserCommand[0] == '1'){
						F.Write("Motor.txt", 'D');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					else if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'D');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					break;
				case 'D':
					if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'D');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					else if(UserCommand[0] == '3'){
						F.Write("Motor.txt", 'U');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					break;
				case 'y':
					if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'D');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					break;
				case '1':
				case '2':
					F.Write("Motor.txt", 'D');
					printf("DOWN܂\n");
					T.WaitSecond(1);
					break;
				case '3':
					F.Write("Motor.txt", 'U');
					printf("UP܂\n");
					T.WaitSecond(1);
					break;
				default:
					break;
				}
			}
			else if(strLimit[2] == 'y'){
				switch(UserCommand[1]){
				case 'U':
					if(UserCommand[0] == '1'){
						F.Write("Motor.txt", 'd');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					else if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'd');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					break;
				case 'D':
					if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'd');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					else if(UserCommand[0] == '3'){
						F.Write("Motor.txt", 'u');
						printf("UP܂\n");
						T.WaitSecond(1);
					}
					break;
				case 'y':
					if(UserCommand[0] == '2'){
						F.Write("Motor.txt", 'd');
						printf("DOWN܂\n");
						T.WaitSecond(1);
					}
					break;
				case '1':
				case '2':
					F.Write("Motor.txt", 'd');
					printf("DOWN܂\n");
					T.WaitSecond(1);
					break;
				case '3':
					F.Write("Motor.txt", 'u');
					printf("UP܂\n");
					T.WaitSecond(1);
					break;
				default:
					break;
				}
			}
		}
		return;
	}
	
	void CQueue::OTOUDChenge(CTimeOut *p_OpenTO)
	{
		char *p_cmd;
		char cmd;
		p_cmd = &cmd;
		cmd = 'N';
		p_tOpenTO = p_OpenTO;
		p_strLimit = &strLimit[0];
		F.ReadString("Limit.txt", p_strLimit, LIMIT);
		if((UD == 'U') && (p_strLimit[9] == 'u') && (p_strLimit[10] == 'd'))
		{
			//	0L,0o,02,2U,2y,0c,2h,03,3D
			if(Check("0L\0","0o\0","02\0","2U\0","2y\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0") == OK)
			{
				F.WriteString("UserCommand.txt", "0o\0");
				Command_Read(p_cmd);
				CheckTurnOpen();
				p_tOpenTO->SetCurrentTime();
				p_tOpenTO->SetPermit(ON);
			}
			else if(Check("0c\0","2h\0","03\0","3D\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0") == ONE_MORE_TIME)
			{
				if(Check("2D\0","01\0","1U\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0") == OK)
				{
					F.WriteString("UserCommand.txt", "0c\0");
					Command_Read(p_cmd);
					Motor(p_OpenTO);
					UD = 'D';
					Write("UserCommand.txt", "2U\0", 'r');
				}
				else
				{
					F.WriteString("UserCommand.txt", "0c\0");
					Command_Read(p_cmd);
					Motor(p_OpenTO);
				}
			}
			else
			{
				F.WriteString("UserCommand.txt", "0c\0");
				Command_Read(p_cmd);
				Motor(p_OpenTO);
			}
		}
		else if((UD == 'D') && (p_strLimit[9] == 'u') && (p_strLimit[10] == 'd'))
		{
			//	0L,0o,02,2D,2y,0c,2h,01,1U
			if(Check("0L\0","0o\0","02\0","2D\0","2y\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0") == OK)
			{
				F.WriteString("UserCommand.txt", "0o\0");
				Command_Read(p_cmd);
				CheckTurnOpen();
				p_tOpenTO->SetCurrentTime();
				p_tOpenTO->SetPermit(ON);
			}
			else if(Check("0c\0","2h\0","01\0","1U\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0") == ONE_MORE_TIME)
			{
				if(Check("2U\0","03\0","3D\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0","NN\0") == OK)
				{
					F.WriteString("UserCommand.txt", "0c\0");
					Command_Read(p_cmd);
					Motor(p_OpenTO);
					UD = 'U';
					Write("UserCommand.txt", "2D\0", 'r');
				}
				else
				{
					F.WriteString("UserCommand.txt", "0c\0");
					Command_Read(p_cmd);
					Motor(p_OpenTO);
				}
			}
			else
			{
				F.WriteString("UserCommand.txt", "0c\0");
				Command_Read(p_cmd);
				Motor(p_OpenTO);
			}
		}
		else
		{
			F.WriteString("UserCommand.txt", "0c\0");
			Command_Read(p_cmd);
			Motor(p_OpenTO);
		}
		
		return;
	}
}
