//	UpDown.cpp

#include "EV_Controller.h"
#include "UpDown.h"

using namespace Time;
using namespace File;

namespace UpDown{
	Position::Position(){
		//	l
		m_UNSL = OFF;
		m_UNST = OFF;
		m_UPSL = OFF;
		m_UPST = OFF;
		p_UnderSlow = &m_UNSL;
		p_UnderStop = &m_UNST;
		p_UpperSlow = &m_UPSL;
		p_UpperStop = &m_UPST;
		//	Sleepp
		fstop = OFF;
		p_fstop = &fstop;
		fmove = OFF;
		p_fmove = &fmove;
	}

	//	㏸
	void UpMotor::OnUpMotor(Position *p_P){
		if(*p_P->p_UpperStop == ON){
			//	Sleepp
			if(*p_P->p_fstop == OFF){
				*p_P->p_fstop = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('s');
				printf("STOP܂\n");
			}
		}
		else if(*p_P->p_UpperSlow == ON){
			//	Sleepp
			*p_P->p_fstop = OFF;
			if(*p_P->p_fmove == OFF){
				*p_P->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('u');
				printf("UP܂\n");
			}
		}
		else if(*p_P->p_UnderSlow == OFF){
			//	Sleepp
			*p_P->p_fstop = OFF;
			if(*p_P->p_fmove == OFF){
				*p_P->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('U');
				printf("UP܂\n");
			}
		}
		else if(*p_P->p_UnderStop == OFF){
			//	Sleepp
			*p_P->p_fstop = OFF;
			if(*p_P->p_fmove == OFF){
				*p_P->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('u');
				printf("UP܂\n");
			}
		}
		else if(*p_P->p_UnderStop == ON){
			//	Sleepp
			*p_P->p_fstop = OFF;
			if(*p_P->p_fmove == OFF){
				*p_P->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('j');
				printf("㏸܂\n");
			}
		}

		return;
	}

	//	~
	void DownMotor::OnDownMotor(Position *p_P){
		if(*p_P->p_UnderStop == ON){
			//	Sleepp
			if(*p_P->p_fstop == OFF){
				*p_P->p_fstop = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('s');
				printf("STOP܂\n");
			}
		}
		else if(*p_P->p_UnderSlow == ON){
			//	Sleepp
			*p_P->p_fstop = OFF;
			if(*p_P->p_fmove == OFF){
				*p_P->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('d');
				printf("DOWN܂\n");
			}
		}
		else if(*p_P->p_UpperSlow == OFF){
			//	Sleepp
			*p_P->p_fstop = OFF;
			if(*p_P->p_fmove == OFF){
				*p_P->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('D');
				printf("DOWN܂\n");
			}
		}
		else if(*p_P->p_UpperStop == OFF){
			//	Sleepp
			*p_P->p_fstop = OFF;
			if(*p_P->p_fmove == OFF){
				*p_P->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('d');
				printf("DOWN܂\n");
			}
		}
		else if(*p_P->p_UpperStop == ON){
			//	Sleepp
			*p_P->p_fstop = OFF;
			if(*p_P->p_fmove == OFF){
				*p_P->p_fmove = ON;
				//	ݎs̖߂Oɕ
				LF.Motor_Write('k');
				printf("~܂\n");
			}
		}

		return;
	}

	//	Gx[^[̈ʒuzO
	WaitPositionChangeLog::WaitPositionChangeLog(){
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
	}

	//	Gx[^[̈ʒuzO
	void WaitPositionChangeLog::OnInitWaitPositionChangeLog(Position *p_P){
		//	ZTl
		//	~bgXCb`̓ǂݍ
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
		tmp = ((strLimit[0] == 'y') ? ON : OFF);
		Checkfmove(p_P->p_UnderStop, p_P->p_fmove, tmp);
		tmp = ((strLimit[1] == 'y') ? ON : OFF);
		Checkfmove(p_P->p_UnderSlow, p_P->p_fmove, tmp);
		tmp = ((strLimit[2] == 'y') ? ON : OFF);
		Checkfmove(p_P->p_UpperSlow, p_P->p_fmove, tmp);
		tmp = ((strLimit[3] == 'y') ? ON : OFF);
		Checkfmove(p_P->p_UpperStop, p_P->p_fmove, tmp);
	}

	//	Gx[^[̈ʒuzO
	void WaitPositionChangeLog::OnWaitUpPositionChangeLog(Position *p_P){
		//	~bgXCb`̓ǂݍ
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
		tmp = (strLimit[0] == 'y') ? ON : OFF;
		Checkfmove(p_P->p_UnderStop, p_P->p_fmove, tmp);
		tmp = (strLimit[1] == 'y') ? ON : OFF;
		Checkfmove(p_P->p_UnderSlow, p_P->p_fmove, tmp);
		tmp = (strLimit[2] == 'y') ? ON : OFF;
		Checkfmove(p_P->p_UpperSlow, p_P->p_fmove, tmp);
		tmp = (strLimit[3] == 'y') ? ON : OFF;
		Checkfmove(p_P->p_UpperStop, p_P->p_fmove, tmp);
	}

	//	Gx[^[̈ʒuzO
	void WaitPositionChangeLog::OnWaitDownPositionChangeLog(Position *p_P){
		//	~bgXCb`̓ǂݍ
		p_strLimit = &strLimit[0];
		LF.Limit_Read(p_strLimit);
		tmp = (strLimit[0] == 'y') ? ON : OFF;
		Checkfmove(p_P->p_UnderStop, p_P->p_fmove, tmp);
		tmp = (strLimit[1] == 'y') ? ON : OFF;
		Checkfmove(p_P->p_UnderSlow, p_P->p_fmove, tmp);
		tmp = (strLimit[2] == 'y') ? ON : OFF;
		Checkfmove(p_P->p_UpperSlow, p_P->p_fmove, tmp);
		tmp = (strLimit[3] == 'y') ? ON : OFF;
		Checkfmove(p_P->p_UpperStop, p_P->p_fmove, tmp);
	}

	void CUpDown::InitUpDown(Position *p_p){
		p_P = p_p;
		p_UPMT = &UPMT;
		p_DNMT = &DNMT;
		p_WPCL = &WPCL;
		//	Gx[^[̈ʒuzO
		//	l
		p_WPCL->OnInitWaitPositionChangeLog(p_P);
	}

	//	㏸
	int	CUpDown::Up(){
		//	㏸mFp
		CLimitFile LF;

		//	㏸^CAEgp
		CTime UTO;

		//	hAJmp
		char strLimit[LIMIT];
		char *p_strLimit;

		//	nkp
		CFile CF;
		char ch;
		char *p_ch;

		//	㏸^CAEgJEgJn
		UTO.SetCurrentTime();

		//	hAJmp
		p_strLimit = &strLimit[0];

		//	nkp
		p_ch = &ch;

		//	܂
		while((*p_P->p_UpperStop == OFF)
			|| (LF.Motor_Read() != 's')){
			//	㏸
			p_UPMT->OnUpMotor(p_P);

			//	㏸^CAEgJEg
			if(UTO.GetCurrentTime() >= POSITIONTIMEOUT){
				printf("㏸ԃ^CAEg\n");
				LF.Motor_Write('s');
				*p_P->p_fstop = OFF;
				*p_P->p_fmove = OFF;
				return NG;
			}

			//	oߎ
			//	Sleep
			Wait_ms(500);

			//	nkp
			CF.Read("Earthquake.txt", p_ch);
			if(ch == 'e'){
				printf("nkɂǐ^]\n");
				LF.Motor_Write('s');
				*p_P->p_fstop = OFF;
				*p_P->p_fmove = OFF;
				CF.Write("Earthquake.txt", 'N');
				CF.Write("Command.txt", 'd');
				return NG;
			}

			//	Gx[^[̈ʒuzO
			p_WPCL->OnWaitUpPositionChangeLog(p_P);
		}
		//	݊K
		printf("̊Kł\n");

		//	߂
		return OK;
	}

	//	~
	int	CUpDown::Down(){
		//	~mFp
		CLimitFile LF;

		//	~^CAEgp
		CTime DTO;

		//	hAJmp
		char strLimit[LIMIT];
		char *p_strLimit;

		//	nkp
		CFile CF;
		char ch;
		char *p_ch;

		//	~^CAEgJEgJn
		DTO.SetCurrentTime();

		//	hAJmp
		p_strLimit = &strLimit[0];

		//	nkp
		p_ch = &ch;

		//	܂
		while((*p_P->p_UnderStop == OFF)
			|| (LF.Motor_Read() != 's')){
			//	~
			p_DNMT->OnDownMotor(p_P);

			//	~^CAEgJEg
			if(DTO.GetCurrentTime() >= POSITIONTIMEOUT){
				printf("~ԃ^CAEg\n");
				LF.Motor_Write('s');
				*p_P->p_fstop = OFF;
				*p_P->p_fmove = OFF;
				return NG;
			}

			//	oߎ
			//	Sleep
			Wait_ms(500);

			//	nkp
			CF.Read("Earthquake.txt", p_ch);
			if(ch == 'e'){
				printf("nkɂǐ^]\n");
				LF.Motor_Write('s');
				*p_P->p_fstop = OFF;
				*p_P->p_fmove = OFF;
				CF.Write("Earthquake.txt", 'N');
				CF.Write("Command.txt", 'd');
				return NG;
			}

			//	Gx[^[̈ʒuzO
			p_WPCL->OnWaitDownPositionChangeLog(p_P);
		}
		//	݊K
		printf("̊Kł\n");

		//	߂
		return OK;
	}
}
