import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.applet.Applet;

//	public class EV_Main extends JFrame implements Runnable
public class EV_Main extends Applet
{
	int width;
	int height;
	JPanel myPanel;
	EV_JPrint print;
	EV_Input in;
	EV_Simulator_Display disp;
	Thread thdisp;
	EV_Controller ctrl;
	Thread thctrl;
	EV_OpenTimeOut OpenTO;
	Thread thOpenTO;
	EV_JPrint Print;
	Thread thPrint;
	
	public void run()
	{
		while(true){
			try{
        //	Sleep
				Thread.sleep(1000);
			}catch(Exception e){}
		}
	}
	
	public void init()
	{
		width = 1380;
		height = 550;
		
		myPanel = new JPanel();
		myPanel.setLayout(new GridLayout(1, 2));
		myPanel.setSize(width, height);
		
		in = new EV_Input();
		in.setSize(460, 550);
		
		disp = new EV_Simulator_Display();
		thdisp = new Thread(disp);
		disp.setSize(460, 550);
		
		ctrl = new EV_Controller();
		thctrl = new Thread(ctrl);
		
		OpenTO = new EV_OpenTimeOut();
		thOpenTO = new Thread(OpenTO);
		
		Print = new EV_JPrint(460, 550);
		thPrint = new Thread(Print);
		Print.setSize(460, 550);
		
		//	Look & Feel̐ݒ
		try{
			//	WindowsX^CLookAndFeelɐݒ
			UIManager.setLookAndFeel(
				"com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
			//	ݒ𔽉f
			SwingUtilities.updateComponentTreeUI(myPanel);
		}
		//	G[ubN
		catch(Exception e)
		{
		}
		
		myPanel.add(in);
		myPanel.add(disp);
		myPanel.add(Print);
		this.add(myPanel);
		thdisp.start();
		thctrl.start();
		thOpenTO.start();
		thPrint.start();
		this.setVisible(true);
	}
/*	
	public static void main(String args[])
	{
		EV_Main evMain = new EV_Main();
		evMain.init();
		evMain.run();
	}
*/
}
